/********************************************************************
  tcpfunc.c
    VIOSɸѴؿ TCP ؿ
*********************************************************************/
#include <netdb.h>               /* addrinfoΤɬ */
#include "vios_lib.h"


/* XTI ץǤ Tcp_listen()̴ؿƤΤ
 * 碌ѤȤޤ
 */
int
Tcp_listen(const char *host, const char *serv, socklen_t *addrlenp)
{
    int		     listenfd, n;
    const int	     on = 1;
    struct addrinfo  hints, *res, *ressave;

    bzero(&hints, sizeof(struct addrinfo));
    hints.ai_flags    = AI_PASSIVE;  /* ǤդΥۥ̾ */
    hints.ai_family   = AF_UNSPEC;   /* IPv4 & IPv6    */
    hints.ai_socktype = SOCK_STREAM; /* TCP      */

    if((n = getaddrinfo(host, serv, &hints, &res)) != 0)
	err_exit("tcp_listen error for %s, %s: %s",\
		 host, serv, gai_strerror(n));
    ressave = res;

    do{	
	listenfd = socket(res->ai_family, res->ai_socktype, \
			  res->ai_protocol);
	if(listenfd < 0) continue;   /*  ԤΤǤ⤦  */

	                             /* Ȥ(SO_REUSEADDR) */
	Setsockopt(listenfd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));

	if(bind(listenfd, res->ai_addr, res->ai_addrlen) == 0) break;
	Close(listenfd);	     /*   bind ⤦    */

    } while((res = res->ai_next) != NULL); 

    if(res == NULL)
	errs_exit("tcp_listen error for %s, %s", host, serv);

    Listen(listenfd, LISTENQ);

    if(addrlenp) /* ץȥ륢ɥ쥹Υ */
	*addrlenp = res->ai_addrlen; 

    freeaddrinfo(ressave);
    return(listenfd);
}

/* XTI ץ(wraplib.c)Ǥ Tcp_connect()̴ؿƤ
 * Τǹ碌ѤȤޤ 
 */
int
Tcp_connect(const char *host, const char *serv)
{
    int		    sockfd, n;
    struct addrinfo hints, *res, *ressave;

    char port[6];
    struct sockaddr_in *addr;

    bzero(&hints, sizeof(struct addrinfo));
    hints.ai_family = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;

    if((n = getaddrinfo(host, serv, &hints, &res)) != 0)
	err_exit("tcp_connect getaddrinfo error for %s, %s: %s",\
		 host, serv, gai_strerror(n));
    ressave = res;

    do {
	sockfd = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
	if(sockfd < 0)  continue;	/* ̵뤷Ƥ⤦ */
	
	if(connect(sockfd, res->ai_addr, res->ai_addrlen) == 0) break;
	Close(sockfd);	                /* ̵뤷Ƥ⤦ */

    } while((res = res->ai_next) != NULL);

    if(res == NULL)
	errs_exit("tcp_connect error for %s, %s", host, serv);

    freeaddrinfo(ressave);
    return(sockfd);
}
