/**************************************************
  fdtd.cc
  FDTD3SyncCacheǡ
  忶ˤήI, ŰV ͤvi.dat˽
  ¬ˤųEz,Hxͤeh.dat˽
***************************************************/

#include<stdio.h>
#include<math.h>
//#define II 41
//#define JJ 41
//#define KK 41
#define NSTOP 300
#define DX 0.002
#define DY 0.002
#define DZ 0.002
#define TAU0 5.0e-10 // 1.0/2.0e9
#define C 3.0e+8
#define EPS0 8.854e-12
#define XMU0 1.2566306e-6
#define LM 4 //width of PML
#define MM 2 //PML
#define RC0 -60.0 //PML
#define IA   14 //(II/3) //center of Excitation source (dipole) 忶
#define JA   14 //(JJ/3) //center of Excitation source (dipole) 忶
#define KGAP 14 //(KK/3) //center of Excitation source (dipole) 忶
#define KA1 (KGAP-1) //center of Excitation source (dipole) 忶
#define KA2 (KGAP+1) //center of Excitation source (dipole) 忶
#define IB   (IA+10) //(II*2/3) //observation point ¬
#define JB   (JA+10) //(JJ*2/3) //observation point ¬
#define KB (KGAP+10) //(KK*2/3) //observation point ¬

void setup_pml(int [6][6][3][2],\
               double *[6], double *[6],\
	       double *[6], double *[6],\
	       double *[6], double *[6],\
               double *[6], double *[6],\
	       double *[6], double *[6],\
	       double *[6], double *[6],\
               int/*II*/,int/*JJ*/,int/*KK*/,/*LM,MM,RC0,DX,DY,DZ,EPS0,XMU0,C,*/double/*dt*/,\
               int/*min_i*/,int/*max_i*/,int/*min_j*/,int/*max_j*/,int/*min_k*/,int/*max_k*/);

void setup_pml_c(double**, double**, double**, double**, double**, double**,\
                 double**, double**, double**, double**, double**, double**,\
                 int/*II*/,int/*JJ*/,int/*KK*/,/*LM,MM,RC0,DX,DY,DZ,EPS0,XMU0,C,*/double/*dt*/,\
                 int/*min_i*/,int/*max_i*/,int/*min_j*/,int/*max_j*/,int/*min_k*/,int/*max_k*/);

vs_module fdtd(fCube_opt Ex, fCube_opt Ey, fCube_opt Ez,
               fCube_opt Hx, fCube_opt Hy, fCube_opt Hz,\
               fCube_opt Cex, fCube_opt Cey, fCube_opt Cez,\
               fCube_opt Cexl, fCube_opt Ceyl, fCube_opt Cezl)
{
    int II,JJ,KK;
    int min_i,max_i, min_j,max_j, min_k,max_k;
    /*double*/float Chx, Chy, Chz;
    double t,dt; //time

    // for PML
    int pmlr[6/*ll*/][6/*Ex,Ey,Ez,Hz,Hy,Hz*/][3/*ijk*/][2/*start,stop*/];
    double *Exy[6], *Exz[6], *Eyx[6], *Eyz[6], *Ezx[6], *Ezy[6],\
           *Hxy[6], *Hxz[6], *Hyx[6], *Hyz[6], *Hzx[6], *Hzy[6],\
           *Cedx,*Cedy,*Cedz, *Cedxl,*Cedyl,*Cedzl,\
           *Chdx,*Chdy,*Chdz, *Chdxl,*Chdyl,*Chdzl;
    int li,lj,lk;

    // for output
    FILE *vi/*Űή*/, *eh/*ų*/;
    int source,observer;
    double Vgap[NSTOP], Cgap[NSTOP]; //voltage & current

    //ͽ
    //if(ip->id==0) fprintf(stderr,"original size %d %d %d\n",orig_width(Ex),orig_heigh(Ex),orig_depth(Ex));
    II=orig_width(Ex); JJ=orig_heigh(Ex); KK=orig_depth(Ex);
    //if(ip->id==0)fprintf(stderr,"%d %d %d\n",II,JJ,KK);
    dt=0.99/C/sqrt(pow((1.0/DX),2.0)+pow((1.0/DY),2.0)+pow((1.0/DZ),2.0));
    //if((ip->id)==0) fprintf(stderr,"dt=%e\n",dt);
    vsSetBoundary3D(0);
    //if((ip->id)==0) fprintf(stderr,"vsSetBoundary3d(0) ok\n");
    parallel(i,j,k) {
          Ex[][][]=0.0;       Ey[][][]=0.0;       Ez[][][]=0.0;
          Hx[][][]=0.0;       Hy[][][]=0.0;       Hz[][][]=0.0;
         Cex[][][]=1.0;      Cey[][][]=1.0;      Cez[][][]=1.0;
        Cexl[][][]=dt/EPS0; Ceyl[][][]=dt/EPS0; Cezl[][][]=dt/EPS0;
    }

    //if((ip->id)==0) fprintf(stderr,"local size %d %d %d\n",local_width(Hx),local_heigh(Hx),local_depth(Hx));

    Chx=dt/(XMU0*DX);    Chy=dt/(XMU0*DY);    Chz=dt/(XMU0*DZ);
    min_i=l2g_x(Ex,local_min_x(Ex)); max_i=l2g_x(Ex,local_max_x(Ex));
    min_j=l2g_y(Ex,local_min_y(Ex)); max_j=l2g_y(Ex,local_max_y(Ex));
    min_k=l2g_z(Ex,local_min_z(Ex)); max_k=l2g_z(Ex,local_max_z(Ex));

    //setup for PML
    setup_pml(pmlr,Exy,Exz,Eyz,Eyx,Ezx,Ezy,Hxy,Hxz,Hyz,Hyx,Hzx,Hzy,\
              II,JJ,KK,/*LM,MM,RC0,DX,DY,DZ,EPS0,XMU0,C,*/dt,\
              min_i,max_i,min_j,max_j,min_k,max_k);
    setup_pml_c(&Cedx,&Cedy,&Cedz, &Cedxl,&Cedyl,&Cedzl,\
                &Chdx,&Chdy,&Chdz, &Chdxl,&Chdyl,&Chdzl,\
                II,JJ,KK,dt,\
                min_i,max_i,min_j,max_j,min_k,max_k);

    if((ip->id)==0) fprintf(stderr,"initialized\n");

    source   = ((min_i<IA)   && (IA  <max_i) &&\
                (min_j<JA)   && (JA  <max_j) &&\
                (min_k<KGAP) && (KGAP<max_k))\
        ? 1 : 0;
    observer = ((min_i<IB)   && (IB  <max_i) &&\
                (min_j<JB)   && (JB  <max_j) &&\
                (min_k<KB)   && (KB  <max_k))\
        ? 1 : 0;
    // output file open
    if(source==1){
	fprintf(stderr,"%d is source\n",ip->id);
        vi=fopen("./vi.dat","w");
        if(vi==NULL){
            fprintf(stderr,"fopen failed\n");
        }//else fprintf(stderr,"%d vi.dat ok\n",ip->id);
    }
    if(observer==1){
	fprintf(stderr,"%d is observer\n",ip->id);
        eh=fopen("./eh.dat","w");
        if(eh==NULL){
            fprintf(stderr,"fopen failed\n");
        }//else fprintf(stderr,"%d eh.dat ok\n",ip->id);
    }

    t=0.0;//

    // PML(ΰǤ), vios parallel(i,j,k)Ϥ
    vsSetBoundary3D(LM);

    if(ip->id==0)fprintf(stderr,"iteration start\n");
    for(int n=0; n<NSTOP; n++) {
        //fprintf(stderr,"%d ",n);

	//E-field update
        parallel(i,j,k) {
            Ex[][][]=Cex[][][]*Ex[][][]
                +Cexl[][][]/DY*(Hz[][][]-Hz[][-1][])
                -Cexl[][][]/DZ*(Hy[][][]-Hy[][][-1]);
            Ey[][][]=Cey[][][]*Ey[][][]
                +Ceyl[][][]/DZ*(Hx[][][]-Hx[][][-1])
                -Ceyl[][][]/DX*(Hz[][][]-Hz[-1][][]);
            Ez[][][]=Cez[][][]*Ez[][][]
                +Cezl[][][]/DX*(Hy[][][]-Hy[-1][][])
                -Cezl[][][]/DY*(Hx[][][]-Hx[][-1][]);
	}

        //Excitation source (dipole) 忶
        if(source){
            for (int k=KA1; k<=KA2; k++) Ez[[IA]][[JA]][[k]]=0.0;
            if (t <= (2.0*TAU0)) Vgap[n]=exp(-pow((4.0/TAU0),2.0)*pow((t-TAU0),2.0));
            else                 Vgap[n]=0.0;
            Ez[[IA]][[JA]][[KGAP]]=(float)(-Vgap[n]/DZ);
            //fprintf(stderr,"%e %e\n",t,Ez[[IA]][[JA]][[KGAP]]/*=-Vgap[n]/DZ*/);
        }

        //apply E PML absorbing boundary condition
        for(int ll=0;ll<6;ll++){
	    int l;

            //Ex
            l=0;
            for(int i=pmlr[ll][0][0][0],li=i;i<=pmlr[ll][0][0][1];i++,li++)
            for(int j=pmlr[ll][0][1][0],lj=j;j<=pmlr[ll][0][1][1];j++,lj++)
            for(int k=pmlr[ll][0][2][0],lk=k;k<=pmlr[ll][0][2][1];k++,lk++){
                Exy[ll][l] = Cedy[lj] * Exy[ll][l]\
                    + Cedyl[lj] * (double)(Hz[[i]][[j]][[k]]-Hz[[i]][[j-1]][[k]]);
                Exz[ll][l] = Cedz[lk] * Exz[ll][l]\
                    + Cedzl[lk] * (double)(Hy[[i]][[j]][[k-1]]-Hy[[i]][[j]][[k]]);
                Ex[[i]][[j]][[k]] = (float)(Exy[ll][l] + Exz[ll][l]);
		l++;
            }//for i,j,k

            //Ey
            l=0;
            for(int i=pmlr[ll][1][0][0],li=i;i<=pmlr[ll][1][0][1];i++,li++)
            for(int j=pmlr[ll][1][1][0],lj=j;j<=pmlr[ll][1][1][1];j++,lj++)
            for(int k=pmlr[ll][1][2][0],lk=k;k<=pmlr[ll][1][2][1];k++,lk++){
                Eyz[ll][l] = Cedz[lk] * Eyz[ll][l]\
                    + Cedzl[lk] * (double)(Hx[[i]][[j]][[k]]-Hx[[i]][[j]][[k-1]]);
                Eyx[ll][l] = Cedx[li] * Eyx[ll][l]\
                    + Cedxl[li] * (double)(Hz[[i-1]][[j]][[k]]-Hz[[i]][[j]][[k]]);
                Ey[[i]][[j]][[k]] = (float)(Eyz[ll][l] + Eyx[ll][l]);
		l++;
            }//for i,j,k

            //Ez
            l=0;
            for(int i=pmlr[ll][2][0][0],li=i;i<=pmlr[ll][2][0][1];i++,li++)
            for(int j=pmlr[ll][2][1][0],lj=j;j<=pmlr[ll][2][1][1];j++,lj++)
            for(int k=pmlr[ll][2][2][0],lk=k;k<=pmlr[ll][2][2][1];k++,lk++){
                Ezx[ll][l] = Cedx[li] * Ezx[ll][l]\
                    + Cedxl[li] * (double)(Hy[[i]][[j]][[k]]-Hy[[i-1]][[j]][[k]]);
                Ezy[ll][l] = Cedy[lj] * Ezy[ll][l]\
                    + Cedyl[lj] * (double)(Hx[[i]][[j-1]][[k]]-Hx[[i]][[j]][[k]]);
                Ez[[i]][[j]][[k]] = (float)(Ezx[ll][l] + Ezy[ll][l]);
		l++;
            }//for i,j,k

        }//for ll

	vsSyncCache(Ex); vsSyncCache(Ey); vsSyncCache(Ez);

        t+=(dt/2.0);//fprintf(stderr,"t=%e\n");

	//H-field update
        parallel(i,j,k) {
            Hx[][][]=Hx[][][]
                -Chy*(Ez[][+1][]-Ez[][][])
                +Chz*(Ey[][][+1]-Ey[][][]);
            Hy[][][]=Hy[][][]
                -Chz*(Ex[][][+1]-Ex[][][])
                +Chx*(Ez[+1][][]-Ez[][][]);
            Hz[][][]=Hz[][][]
                -Chx*(Ey[+1][][]-Ey[][][])
                +Chy*(Ex[][+1][]-Ex[][][]);
	}

        //apply H PML absorbing boundary condition
        for(int ll=0;ll<6;ll++){
	    int l;

            //Hx
            l=0;
            for(int i=pmlr[ll][3][0][0],li=i;i<=pmlr[ll][3][0/*i*/][1/*stop*/];i++,li++)
            for(int j=pmlr[ll][3][1][0],lj=j;j<=pmlr[ll][3][1/*j*/][1/*stop*/];j++,lj++)
            for(int k=pmlr[ll][3][2][0],lk=k;k<=pmlr[ll][3][2/*k*/][1/*stop*/];k++,lk++){
                Hxy[ll][l] = Chdy[lj] * Hxy[ll][l]\
                    - Chdyl[lj] * (double)(Ez[[i]][[j+1]][[k]]-Ez[[i]][[j]][[k]]);
                Hxz[ll][l] = Chdz[lk] * Hxz[ll][l]\
                    + Chdzl[lk] * (double)(Ey[[i]][[j]][[k+1]]-Ey[[i]][[j]][[k]]);
                Hx[[i]][[j]][[k]] = (float)(Hxy[ll][l] + Hxz[ll][l]);
		l++;
            }//for i,j,k

            //Hy
            l=0;
            for(int i=pmlr[ll][4][0][0],li=i;i<=pmlr[ll][4][0/*i*/][1/*stop*/];i++,li++)
            for(int j=pmlr[ll][4][1][0],lj=j;j<=pmlr[ll][4][1/*j*/][1/*stop*/];j++,lj++)
            for(int k=pmlr[ll][4][2][0],lk=k;k<=pmlr[ll][4][2/*k*/][1/*stop*/];k++,lk++){
                Hyz[ll][l] = Chdz[lk] * Hyz[ll][l]\
                    - Chdzl[lk] * (double)(Ex[[i]][[j]][[k+1]]-Ex[[i]][[j]][[k]]);
                Hyx[ll][l] = Chdx[li] * Hyx[ll][l]\
                    + Chdxl[li] * (double)(Ez[[i+1]][[j]][[k]]-Ez[[i]][[j]][[k]]);
                Hy[[i]][[j]][[k]] = (float)(Hyz[ll][l] + Hyx[ll][l]);
		l++;
            }//for i,j,k

            //Hz
            l=0;
            for(int i=pmlr[ll][5][0][0],li=i;i<=pmlr[ll][5][0/*i*/][1/*stop*/];i++,li++)
            for(int j=pmlr[ll][5][1][0],lj=j;j<=pmlr[ll][5][1/*j*/][1/*stop*/];j++,lj++)
            for(int k=pmlr[ll][5][2][0],lk=k;k<=pmlr[ll][5][2/*k*/][1/*stop*/];k++,lk++){
                Hzx[ll][l] = Chdx[li] * Hzx[ll][l]\
                    - Chdxl[li] * (double)(Ey[[i+1]][[j]][[k]]-Ey[[i]][[j]][[k]]);
                Hzy[ll][l] = Chdy[lj] * Hzy[ll][l]\
                    + Chdyl[lj] * (double)(Ex[[i]][[j+1]][[k]]-Ex[[i]][[j]][[k]]);
                Hz[[i]][[j]][[k]] = (float)(Hzx[ll][l] + Hzy[ll][l]);
		l++;
            }//for i,j,k

        }//for ll = 0, 5

	vsSyncCache(Hx); vsSyncCache(Hy); vsSyncCache(Hz);

        t+=(dt/2.0);//fprintf(stderr,"t=%e\n");

        if(source){
            //Save temporary voltage and current at the gap
            Cgap[n]=(double)((-Hx[[IA]][[JA]][[KGAP]]+Hx[[IA]][[JA-1]][[KGAP]])*DX\
                             +(Hy[[IA]][[JA]][[KGAP]]-Hy[[IA-1]][[JA]][[KGAP]])*DY);
            //fprintf(stderr,"%e %e %e\n",t,Vgap[n],Cgap[n]);
              fprintf(    vi,"%e %e %e\n",t,Vgap[n],Cgap[n]);
        }

        if(observer){
            //Save temporary E and H fields
            //fprintf(stderr,"%e %e %e\n",t,(double)Ez[[IB]][[JB]][[KB]],(double)Hx[[IB]][[JB]][[KB]]);
              fprintf(    eh,"%e %e %e\n",t,(double)Ez[[IB]][[JB]][[KB]],(double)Hx[[IB]][[JB]][[KB]]);
        }

	//fprintf(stderr,"done.\n");

    }//for n
    if(ip->id==0)fprintf(stderr,"done\n\a");
    
    //output file close
    if(source){
        fclose(vi);
    }
    if(observer){
        fclose(eh);
    }

}//vs_module pfdtd(fCube_opt data)


void setup_pml(int pmlr[6][6][3][2],\
               double *Exy[6], double *Exz[6],\
               double *Eyz[6], double *Eyx[6],\
               double *Ezx[6], double *Ezy[6],\
               double *Hxy[6], double *Hxz[6],\
               double *Hyz[6], double *Hyx[6],\
               double *Hzx[6], double *Hzy[6],\
               int II, int JJ, int KK,/*LM,MM,RC0,DX,DY,DZ,EPS0,XMU0,C,*/double dt,\
               int min_i, int max_i, int min_j, int max_j, int min_k, int max_k)
{
//#define max(A,B) ((A)>(B)?(A):(B))
//#define min(A,B) ((A)<(B)?(A):(B))
    double Sglmax/**/, Sgle[LM]/*ų*/, Sglh[LM]/**/;

    //if(ip->id==0)fprintf(stderr,"setup for PML start\n");

    //if(ip->id==0)fprintf(stderr,"PML region outside\n");//¦
    for(int ll=0;ll<6;ll++){
        //Ex
        pmlr[ll][0][0/*i*/][0/*start*/]=max(   0,min_i);
        pmlr[ll][0][0/*i*/][1/*stop */]=min(II-2,max_i);
        pmlr[ll][0][1/*j*/][0/*start*/]=max(   1,min_j);
        pmlr[ll][0][1/*j*/][1/*stop */]=min(JJ-2,max_j);
        pmlr[ll][0][2/*k*/][0/*start*/]=max(   1,min_k);
        pmlr[ll][0][2/*k*/][1/*stop */]=min(KK-2,max_k);
        //Ey
        pmlr[ll][1][0/*i*/][0/*start*/]=max(   1,min_i);
        pmlr[ll][1][0/*i*/][1/*stop */]=min(II-2,max_i);
        pmlr[ll][1][1/*j*/][0/*start*/]=max(   0,min_j);
        pmlr[ll][1][1/*j*/][1/*stop */]=min(JJ-2,max_j);
        pmlr[ll][1][2/*k*/][0/*start*/]=max(   1,min_k);
        pmlr[ll][1][2/*k*/][1/*stop */]=min(KK-2,max_k);
        //Ez
        pmlr[ll][2][0/*i*/][0/*start*/]=max(   1,min_i);
        pmlr[ll][2][0/*i*/][1/*stop */]=min(II-2,max_i);
        pmlr[ll][2][1/*j*/][0/*start*/]=max(   1,min_j);
        pmlr[ll][2][1/*j*/][1/*stop */]=min(JJ-2,max_j);
        pmlr[ll][2][2/*k*/][0/*start*/]=max(   0,min_k);
        pmlr[ll][2][2/*k*/][1/*stop */]=min(KK-2,max_k);
        //Hx
        pmlr[ll][3][0/*i*/][0/*start*/]=max(   1,min_i);
        pmlr[ll][3][0/*i*/][1/*stop */]=min(II-2,max_i);
        pmlr[ll][3][1/*j*/][0/*start*/]=max(   0,min_j);
        pmlr[ll][3][1/*j*/][1/*stop */]=min(JJ-2,max_j);
        pmlr[ll][3][2/*k*/][0/*start*/]=max(   0,min_k);
        pmlr[ll][3][2/*k*/][1/*stop */]=min(KK-2,max_k);
        //Hy
        pmlr[ll][4][0/*i*/][0/*start*/]=max(   0,min_i);
        pmlr[ll][4][0/*i*/][1/*stop */]=min(II-2,max_i);
        pmlr[ll][4][1/*j*/][0/*start*/]=max(   1,min_j);
        pmlr[ll][4][1/*j*/][1/*stop */]=min(JJ-2,max_j);
        pmlr[ll][4][2/*k*/][0/*start*/]=max(   0,min_k);
        pmlr[ll][4][2/*k*/][1/*stop */]=min(KK-2,max_k);
        //Hz
        pmlr[ll][5][0/*i*/][0/*start*/]=max(   0,min_i);
        pmlr[ll][5][0/*i*/][1/*stop */]=min(II-2,max_i);
        pmlr[ll][5][1/*j*/][0/*start*/]=max(   0,min_j);
        pmlr[ll][5][1/*j*/][1/*stop */]=min(JJ-2,max_j);
        pmlr[ll][5][2/*k*/][0/*start*/]=max(   1,min_k);
        pmlr[ll][5][2/*k*/][1/*stop */]=min(KK-2,max_k);
    }
    //if(ip->id==0)fprintf(stderr,"PML region inside\n");//¦
    //Ex
    pmlr[0][0][0/*i*/][1/*stop */]=min(   LM-1,max_i);
    pmlr[1][0][0/*i*/][0/*start*/]=max(II-LM-1,min_i);
    pmlr[2][0][1/*j*/][1/*stop */]=min(   LM-1,max_j);
    pmlr[3][0][1/*j*/][0/*start*/]=max(JJ-LM,min_j);
    pmlr[4][0][2/*k*/][1/*stop */]=min(   LM-1,max_k);
    pmlr[5][0][2/*k*/][0/*start*/]=max(KK-LM,min_k);
    //Ey
    pmlr[0][1][0/*i*/][1/*stop */]=min(   LM-1,max_i);
    pmlr[1][1][0/*i*/][0/*start*/]=max(II-LM-1,min_i);
    pmlr[2][1][1/*j*/][1/*stop */]=min(   LM-1,max_j);
    pmlr[3][1][1/*j*/][0/*start*/]=max(JJ-LM,min_j);
    pmlr[4][1][2/*k*/][1/*stop */]=min(   LM-1,max_k);
    pmlr[5][1][2/*k*/][0/*start*/]=max(KK-LM,min_k);
    //Ez
    pmlr[0][2][0/*i*/][1/*stop */]=min(   LM-1,max_i);
    pmlr[1][2][0/*i*/][0/*start*/]=max(II-LM,min_i);
    pmlr[2][2][1/*j*/][1/*stop */]=min(   LM-1,max_j);
    pmlr[3][2][1/*j*/][0/*start*/]=max(JJ-LM,min_j);
    pmlr[4][2][2/*k*/][1/*stop */]=min(   LM-1,max_k);
    pmlr[5][2][2/*k*/][0/*start*/]=max(KK-LM-1,min_k);
    //Hx
    pmlr[0][3][0/*i*/][1/*stop */]=min(   LM-1,max_i);
    pmlr[1][3][0/*i*/][0/*start*/]=max(II-LM,min_i);
    pmlr[2][3][1/*j*/][1/*stop */]=min(   LM-1,max_j);
    pmlr[3][3][1/*j*/][0/*start*/]=max(JJ-LM-1,min_j);
    pmlr[4][3][2/*k*/][1/*stop */]=min(   LM-1,max_k);
    pmlr[5][3][2/*k*/][0/*start*/]=max(KK-LM-1,min_k);
    //Hy
    pmlr[0][4][0/*i*/][1/*stop */]=min(   LM-1,max_i);
    pmlr[1][4][0/*i*/][0/*start*/]=max(II-LM-1,min_i);
    pmlr[2][4][1/*j*/][1/*stop */]=min(   LM-1,max_j);
    pmlr[3][4][1/*j*/][0/*start*/]=max(JJ-LM,min_j);
    pmlr[4][4][2/*k*/][1/*stop */]=min(   LM-1,max_k);
    pmlr[5][4][2/*k*/][0/*start*/]=max(KK-LM-1,min_k);
    //Hz
    pmlr[0][5][0/*i*/][1/*stop */]=min(   LM-1,max_i);
    pmlr[1][5][0/*i*/][0/*start*/]=max(II-LM-1,min_i);
    pmlr[2][5][1/*j*/][1/*stop */]=min(   LM-1,max_j);
    pmlr[3][5][1/*j*/][0/*start*/]=max(JJ-LM-1,min_j);
    pmlr[4][5][2/*k*/][1/*stop */]=min(   LM-1,max_k);
    pmlr[5][5][2/*k*/][0/*start*/]=max(KK-LM,min_k);

    //if(ip->id==0)fprintf(stderr,"make and initialize E and H fields in PML region\n");
    for(int ll=0;ll<6;ll++){
        //Ex
	if(pmlr[ll][0][0/*i*/][0/*start*/]<=pmlr[ll][0][0/*i*/][1/*stop*/]\
	 &&pmlr[ll][0][1/*j*/][0/*start*/]<=pmlr[ll][0][1/*j*/][1/*stop*/]\
	 &&pmlr[ll][0][2/*k*/][0/*start*/]<=pmlr[ll][0][2/*k*/][1/*stop*/]){
	    int l;
	    Exy[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][0][0][1]-pmlr[ll][0][0][0]+1)\
                                    *(pmlr[ll][0][1][1]-pmlr[ll][0][1][0]+1)\
                                    *(pmlr[ll][0][2][1]-pmlr[ll][0][2][0]+1));
	    Exz[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][0][0][1]-pmlr[ll][0][0][0]+1)\
                                    *(pmlr[ll][0][1][1]-pmlr[ll][0][1][0]+1)\
                                    *(pmlr[ll][0][2][1]-pmlr[ll][0][2][0]+1));
	    //initialize E and H fields in PML
	    for(l=0;l<(pmlr[ll][0][0][1]-pmlr[ll][0][0][0]+1)\
		     *(pmlr[ll][0][1][1]-pmlr[ll][0][1][0]+1)\
                     *(pmlr[ll][0][2][1]-pmlr[ll][0][2][0]+1);l++){
		Exy[ll][l]=0.0; Exz[ll][l]=0.0;
	    }//for l
	}//if

        //Ey
	if(pmlr[ll][1][0/*i*/][0/*start*/]<=pmlr[ll][1][0/*i*/][1/*stop*/]\
	 &&pmlr[ll][1][1/*j*/][0/*start*/]<=pmlr[ll][1][1/*j*/][1/*stop*/]\
	 &&pmlr[ll][1][2/*k*/][0/*start*/]<=pmlr[ll][1][2/*k*/][1/*stop*/]){
	    int l;
	    Eyz[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][1][0][1]-pmlr[ll][1][0][0]+1)\
                                    *(pmlr[ll][1][1][1]-pmlr[ll][1][1][0]+1)\
                                    *(pmlr[ll][1][2][1]-pmlr[ll][1][2][0]+1));
	    Eyx[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][1][0][1]-pmlr[ll][1][0][0]+1)\
                                    *(pmlr[ll][1][1][1]-pmlr[ll][1][1][0]+1)\
                                    *(pmlr[ll][1][2][1]-pmlr[ll][1][2][0]+1));
	    //initialize E and H fields in PML
	    for(l=0;l<(pmlr[ll][1][0][1]-pmlr[ll][1][0][0]+1)\
		     *(pmlr[ll][1][1][1]-pmlr[ll][1][1][0]+1)\
                     *(pmlr[ll][1][2][1]-pmlr[ll][1][2][0]+1);l++){
		Eyz[ll][l]=0.0; Eyx[ll][l]=0.0;
	    }//for l
	}//if

        //Ez
	if(pmlr[ll][2][0/*i*/][0/*start*/]<=pmlr[ll][2][0/*i*/][1/*stop*/]\
	 &&pmlr[ll][2][1/*j*/][0/*start*/]<=pmlr[ll][2][1/*j*/][1/*stop*/]\
	 &&pmlr[ll][2][2/*k*/][0/*start*/]<=pmlr[ll][2][2/*k*/][1/*stop*/]){
	    int l;
	    Ezx[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][2][0][1]-pmlr[ll][2][0][0]+1)\
                                    *(pmlr[ll][2][1][1]-pmlr[ll][2][1][0]+1)\
                                    *(pmlr[ll][2][2][1]-pmlr[ll][2][2][0]+1));
	    Ezy[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][2][0][1]-pmlr[ll][2][0][0]+1)\
                                    *(pmlr[ll][2][1][1]-pmlr[ll][2][1][0]+1)\
                                    *(pmlr[ll][2][2][1]-pmlr[ll][2][2][0]+1));
	    //initialize E and H fields in PML
	    for(l=0;l<(pmlr[ll][2][0][1]-pmlr[ll][2][0][0]+1)\
		     *(pmlr[ll][2][1][1]-pmlr[ll][2][1][0]+1)\
                     *(pmlr[ll][2][2][1]-pmlr[ll][2][2][0]+1);l++){
		Ezx[ll][l]=0.0; Ezy[ll][l]=0.0;
	    }//for l
	}//if

        //Hx
	if(pmlr[ll][3][0/*i*/][0/*start*/]<=pmlr[ll][3][0/*i*/][1/*stop*/]\
	 &&pmlr[ll][3][1/*j*/][0/*start*/]<=pmlr[ll][3][1/*j*/][1/*stop*/]\
	 &&pmlr[ll][3][2/*k*/][0/*start*/]<=pmlr[ll][3][2/*k*/][1/*stop*/]){
	    int l;
	    Hxy[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][3][0][1]-pmlr[ll][3][0][0]+1)\
                                    *(pmlr[ll][3][1][1]-pmlr[ll][3][1][0]+1)\
                                    *(pmlr[ll][3][2][1]-pmlr[ll][3][2][0]+1));
	    Hxz[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][3][0][1]-pmlr[ll][3][0][0]+1)\
                                    *(pmlr[ll][3][1][1]-pmlr[ll][3][1][0]+1)\
                                    *(pmlr[ll][3][2][1]-pmlr[ll][3][2][0]+1));
	    //initialize E and H fields in PML
	    for(l=0;l< (pmlr[ll][3][0][1]-pmlr[ll][3][0][0]+1)\
                      *(pmlr[ll][3][1][1]-pmlr[ll][3][1][0]+1)\
                      *(pmlr[ll][3][2][1]-pmlr[ll][3][2][0]+1);l++){
		Hxy[ll][l]=0.0; Hxz[ll][l]=0.0;
	    }//for l
	}//if

        //Hy
	if(pmlr[ll][4][0/*i*/][0/*start*/]<=pmlr[ll][4][0/*i*/][1/*stop*/]\
	 &&pmlr[ll][4][1/*j*/][0/*start*/]<=pmlr[ll][4][1/*j*/][1/*stop*/]\
	 &&pmlr[ll][4][2/*k*/][0/*start*/]<=pmlr[ll][4][2/*k*/][1/*stop*/]){
	    int l;
	    Hyz[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][4][0][1]-pmlr[ll][4][0][0]+1)\
                                    *(pmlr[ll][4][1][1]-pmlr[ll][4][1][0]+1)\
                                    *(pmlr[ll][4][2][1]-pmlr[ll][4][2][0]+1));
	    Hyx[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][4][0][1]-pmlr[ll][4][0][0]+1)\
                                    *(pmlr[ll][4][1][1]-pmlr[ll][4][1][0]+1)\
                                    *(pmlr[ll][4][2][1]-pmlr[ll][4][2][0]+1));
	    //initialize E and H fields in PML
	    for(l=0;l< (pmlr[ll][4][0][1]-pmlr[ll][4][0][0]+1)\
                      *(pmlr[ll][4][1][1]-pmlr[ll][4][1][0]+1)\
                      *(pmlr[ll][4][2][1]-pmlr[ll][4][2][0]+1);l++){
		Hyz[ll][l]=0.0; Hyx[ll][l]=0.0;
	    }//for l
	}//if

        //Hz
	if(pmlr[ll][5][0/*i*/][0/*start*/]<=pmlr[ll][5][0/*i*/][1/*stop*/]\
	 &&pmlr[ll][5][1/*j*/][0/*start*/]<=pmlr[ll][5][1/*j*/][1/*stop*/]\
	 &&pmlr[ll][5][2/*k*/][0/*start*/]<=pmlr[ll][5][2/*k*/][1/*stop*/]){
	    int l;
	    Hzx[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][5][0][1]-pmlr[ll][5][0][0]+1)\
                                    *(pmlr[ll][5][1][1]-pmlr[ll][5][1][0]+1)\
                                    *(pmlr[ll][5][2][1]-pmlr[ll][5][2][0]+1));
	    Hzy[ll]=(double*)malloc(sizeof(double)\
                                    *(pmlr[ll][5][0][1]-pmlr[ll][5][0][0]+1)\
                                    *(pmlr[ll][5][1][1]-pmlr[ll][5][1][0]+1)\
                                    *(pmlr[ll][5][2][1]-pmlr[ll][5][2][0]+1));
	    //initialize E and H fields in PML
	    for(l=0;l< (pmlr[ll][5][0][1]-pmlr[ll][5][0][0]+1)\
                      *(pmlr[ll][5][1][1]-pmlr[ll][5][1][0]+1)\
                      *(pmlr[ll][5][2][1]-pmlr[ll][5][2][0]+1);l++){
		Hzx[ll][l]=0.0; Hzy[ll][l]=0.0;
	    }//for l
	}//if
    }//for ll = 0,5

    return;

}//void setup_pml()


void setup_pml_c(double **Cedx , double **Cedy , double **Cedz ,\
                 double **Cedxl, double **Cedyl, double **Cedzl,\
                 double **Chdx , double **Chdy , double **Chdz ,\
                 double **Chdxl, double **Chdyl, double **Chdzl,\
                 int II, int JJ, int KK,/*LM,MM,RC0,DX,DY,DZ,EPS0,XMU0,C,*/double dt,\
                 int min_i, int max_i, int min_j, int max_j, int min_k, int max_k)
{
//#define max(A,B) ((A)>(B)?(A):(B))
//#define min(A,B) ((A)<(B)?(A):(B))
    double Sglmax/**/, Sgle[LM]/*ų*/, Sglh[LM]/**/;

    //if(ip->id==0)fprintf(stderr,"generate constants for field update equations in PML region\n");
    //E
    (*Cedx )=(double*)malloc(sizeof(double)*II);
    (*Cedxl)=(double*)malloc(sizeof(double)*II);
    (*Cedy )=(double*)malloc(sizeof(double)*JJ);
    (*Cedyl)=(double*)malloc(sizeof(double)*JJ);
    (*Cedz )=(double*)malloc(sizeof(double)*KK);
    (*Cedzl)=(double*)malloc(sizeof(double)*KK);
    //H
    (*Chdx )=(double*)malloc(sizeof(double)*II);
    (*Chdxl)=(double*)malloc(sizeof(double)*II);
    (*Chdy )=(double*)malloc(sizeof(double)*JJ);
    (*Chdyl)=(double*)malloc(sizeof(double)*JJ);
    (*Chdz )=(double*)malloc(sizeof(double)*KK);
    (*Chdzl)=(double*)malloc(sizeof(double)*KK);

    for(int i=0;i<II;i++){
        (*Cedx)[i]=1.0; (*Cedxl)[i]=dt/EPS0/DX;
    }
    for(int i=0;i<II;i++){
        (*Chdx)[i]=1.0; (*Chdxl)[i]=dt/XMU0/DX;
    }
    for(int j=0;j<JJ;j++){
        (*Cedy)[j]=1.0; (*Cedyl)[j]=dt/EPS0/DY;
    }
    for(int j=0;j<JJ;j++){
        (*Chdy)[j]=1.0; (*Chdyl)[j]=dt/XMU0/DY;
    }
    for(int k=0;k<KK;k++){
        (*Cedz)[k]=1.0; (*Cedzl)[k]=dt/EPS0/DZ;
    }
    for(int k=0;k<KK;k++){
        (*Chdz)[k]=1.0; (*Chdzl)[k]=dt/XMU0/DZ;
    }

    //if(ip->id==0)fprintf(stderr,"constants C at edge\n");
    Sglmax = -(MM+1)*EPS0*C/(2.0*LM*DX)*RC0;
    //if(ip->id==0)fprintf(stderr,"Sglmax %e\n",Sglmax);
    for(int l=1;l<=LM;l++){
         Sgle[l-1] = Sglmax*pow(((LM-l+1.0)/LM),(double)MM);
         Sglh[l-1] = Sglmax*pow(((LM-l+0.5)/LM),(double)MM);
         //if(ip->id==0)fprintf(stderr,"%e %e\n",Sgle[l-1],Sglh[l-1]);
    }

    //X
    for(int i=0;i<LM;i++){
        (*Cedx)[i]=                (1.0-Sgle[i]*dt/(2.0*EPS0))\
	                          /(1.0+Sgle[i]*dt/(2.0*EPS0));
        (*Cedxl)[i]     =(dt/EPS0)/(1.0+Sgle[i]*dt/(2.0*EPS0))/DX;
    }
    for(int i=0;i<=LM-1;i++){
        (*Chdx)[i]                =(1.0-Sglh[i]*dt/(2.0*EPS0))\
	                          /(1.0+Sglh[i]*dt/(2.0*EPS0));
        (*Chdxl)[i]     =(dt/XMU0)/(1.0+Sglh[i]*dt/(2.0*EPS0))/DX;
    }
    for(int i=0;i<LM;i++){
        (*Cedx)[II-1-i]           =(1.0-Sgle[i]*dt/(2.0*EPS0))\
                                  /(1.0+Sgle[i]*dt/(2.0*EPS0));
        (*Cedxl)[II-1-i]=(dt/EPS0)/(1.0+Sgle[i]*dt/(2.0*EPS0))/DX;
    }
    for(int i=0;i<LM;i++){
        (*Chdx)[II-1-i]           =(1.0-Sglh[i]*dt/(2.0*EPS0))\
                                  /(1.0+Sglh[i]*dt/(2.0*EPS0));
        (*Chdxl)[II-1-i]=(dt/XMU0)/(1.0+Sglh[i]*dt/(2.0*EPS0))/DX;
    }

    //Y
    for(int j=0;j<LM;j++){
        (*Cedy)[j]                =(1.0-Sgle[j]*dt/(2.0*EPS0))\
	                          /(1.0+Sgle[j]*dt/(2.0*EPS0));
        (*Cedyl)[j]     =(dt/EPS0)/(1.0+Sgle[j]*dt/(2.0*EPS0))/DY;
    }
    for(int j=0;j<=LM-1;j++){
        (*Chdy)[j]                =(1.0-Sglh[j]*dt/(2.0*EPS0))\
                                  /(1.0+Sglh[j]*dt/(2.0*EPS0));
        (*Chdyl)[j]     =(dt/XMU0)/(1.0+Sglh[j]*dt/(2.0*EPS0))/DY;
    }
    for(int j=0;j<LM;j++){
        (*Cedy)[JJ-1-j]           =(1.0-Sgle[j]*dt/(2.0*EPS0))\
                                  /(1.0+Sgle[j]*dt/(2.0*EPS0));
        (*Cedyl)[JJ-1-j]=(dt/EPS0)/(1.0+Sgle[j]*dt/(2.0*EPS0))/DY;
    }
    for(int j=0;j<LM;j++){
        (*Chdy)[JJ-1-j]           =(1.0-Sglh[j]*dt/(2.0*EPS0))\
                                  /(1.0+Sglh[j]*dt/(2.0*EPS0));
        (*Chdyl)[JJ-1-j]=(dt/XMU0)/(1.0+Sglh[j]*dt/(2.0*EPS0))/DY;
    }

    //Z
    for(int k=0;k<LM;k++){
        (*Cedz)[k]                =(1.0-Sgle[k]*dt/(2.0*EPS0))\
                                  /(1.0+Sgle[k]*dt/(2.0*EPS0));
        (*Cedzl)[k]     =(dt/EPS0)/(1.0+Sgle[k]*dt/(2.0*EPS0))/DZ;
    }
    for(int k=0;k<=LM-1;k++){
        (*Chdz)[k]                =(1.0-Sglh[k]*dt/(2.0*EPS0))\
                                  /(1.0+Sglh[k]*dt/(2.0*EPS0));
        (*Chdzl)[k]     =(dt/XMU0)/(1.0+Sglh[k]*dt/(2.0*EPS0))/DZ;
    }
    for(int k=0;k<LM;k++){
        (*Cedz)[KK-1-k]           =(1.0-Sgle[k]*dt/(2.0*EPS0))\
                                  /(1.0+Sgle[k]*dt/(2.0*EPS0));
        (*Cedzl)[KK-1-k]=(dt/EPS0)/(1.0+Sgle[k]*dt/(2.0*EPS0))/DZ;
    }
    for(int k=0;k<LM;k++){
        (*Chdz)[KK-1-k]           =(1.0-Sglh[k]*dt/(2.0*EPS0))\
                                  /(1.0+Sglh[k]*dt/(2.0*EPS0));
        (*Chdzl)[KK-1-k]=(dt/XMU0)/(1.0+Sglh[k]*dt/(2.0*EPS0))/DZ;
    }
    //if(ip->id==0)fprintf(stderr,"setup for PML finished\n");
    return;
}//void setup_pml_c()
