/********************************************************************
  vios_module.h
    VIOSɸؿ 󥯥롼ɥإå
*********************************************************************/
#include <stdio.h>
#include <math.h>
#ifndef __linux__
#include <sys/ddi.h>
#endif

#include "vsvalue.h"
#include "vsvalue_opt.h"
#include "vsImage.h"
#include "vsImage_opt.h"
#include "vsCube.h"
#include "vsCube_opt.h"

#ifndef __VIOS_MODULE_H
#define __VIOS_MODULE_H

typedef void			vs_module;

typedef vsvalue<int>		ivalue;
typedef vsvalue<FLOAT>		fvalue;
typedef vsImage<int>		iImage;
typedef vsImage<FLOAT>		fImage;
typedef vsCube<int>		iCube;
typedef vsCube<FLOAT>		fCube;

typedef vsvalue_opt<int>	ivalue_opt;
typedef vsvalue_opt<FLOAT>	fvalue_opt;
typedef vsImage_opt<int>	iImage_opt;
typedef vsImage_opt<FLOAT>	fImage_opt;
typedef vsCube_opt<int>		iCube_opt;
typedef vsCube_opt<FLOAT>	fCube_opt;


static vs_module_tab* _vs_p   = &module_tab;

#define	l2g_x(a,llx)	((llx) + a->info->div_info[0].index)
#define l2g_y(a,lly)	((lly) + a->info->div_info[1].index)
#define l2g_z(a,llz)	((llz) + a->info->div_info[2].index)

#define g2l_x(a,llx)	((llx) - a->info->div_info[0].index)
//#define g2l_x(a,gx)     (a->info->gxtable[gx])
#define g2l_y(a,lly)	((lly) - a->info->div_info[1].index)
#define g2l_z(a,llz)	((llz) - a->info->div_info[2].index)

#define orig_width(a)	(a->info->orig->width)
#define orig_heigh(a)	(a->info->orig->heigh)
#define orig_depth(a)	(a->info->orig->heigh)

#define local_width(a)	(a->info->local->width)
#define local_heigh(a)	(a->info->local->heigh)
#define local_depth(a)	(a->info->local->depth)

#define local_min_x(a)	(a->info->cache[2])
#define local_max_x(a)	(a->info->local->width - a->info->cache[3] -1)
#define local_min_y(a)  (a->info->cache[0])
#define local_max_y(a)	(a->info->local->heigh - a->info->cache[1] -1)
#define local_min_z(a)  (a->info->cache[4])
#define local_max_z(a)	(a->info->local->depth - a->info->cache[5] -1)

#define	 ValCopy(a,b)	(a->ValCopy(b))
#define  ImgCopy(a,b)	(a->ImgCopy(b))
#define CubeCopy(a,b)	(a->CubeCopy(b))

#define vsSetBoundary1D(i)	(ip->SetDike(i,_vs_p->base[0]))
#define vsSetBoundary2D(i)	(ip->SetDike(i,_vs_p->base[1]))
#define vsSetBoundary3D(i)	(ip->SetDike(i,_vs_p->base[2]))

#define vsSync()		(ip->SendSync())
#define vsSyncCache(a)		(ip->SendSyncCache(a->info, a->id))
#define vsUnion(a, i)		(ip->SendUnion(a->info, a->id, i))
#define vsVote(a, pos, val)	(ip->SendVote (a->info, a->id, pos, val))

#define comm_in			ip->comm_in
#define comm_out		ip->comm_out
#define comm_ck			ip->comm_ck
#define comm_no			ip->comm_no

#define vsGetID()		ip->id
#define vsGetHostNum()          exec_info.host_num  //ɲ

void
vsDataWait1D()
{
    Pthread_mutex_lock(&exec_info.lock);
    Pthread_mutex_unlock(&exec_info.lock);
}
void
vsDataWait2D()		
{
    int t_heigh  = _vs_p->base[1]->dsize / _vs_p->base[1]->local->width;

    Pthread_mutex_lock(&exec_info.lock);
    while(t_heigh != _vs_p->base[1]->local->heigh) {
	Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    }
    Pthread_mutex_unlock(&exec_info.lock);
}
void
vsDataWait3D()
{
    int	t_depth = _vs_p->base[2]->dsize / \
	         (_vs_p->base[2]->local->width * _vs_p->base[2]->local->heigh);

    Pthread_mutex_lock(&exec_info.lock);
    while(t_depth != _vs_p->base[1]->local->depth) {
	Pthread_cond_wait(&exec_info.cond, &exec_info.lock);
    }
    Pthread_mutex_unlock(&exec_info.lock);
}


//
// ʲ parallel ʸ  -------------------------------------------
//

// 1-Dʬ˺ʬѤʤ
#define parallel1(lx)							\
    {									\
	int _vs_width = 0;						\
        int _vs_x,_vs_c,_vs_IS,_vs_point,_vs_num;                       \
        Pthread_mutex_lock(&exec_info.lock);				\
	_vs_width = _vs_p->base[0]->local->width;			\
	Pthread_mutex_unlock(&exec_info.lock);				\
\
        int width = _vs_width - _vs_p->base[0]->cache[2] 		\
		              - _vs_p->base[0]->cache[3];		\
        if(_vs_p->base[0]->dtype == dCOLCYC){                           \
           _vs_x = _vs_p->base[0]->div_hint.x_divide;                   \
           _vs_num = _vs_p->base[0]->orig->width /(_vs_x*exec_info.host_num);\
	   _vs_c = _vs_p->base[0]->c;                                   \
	   _vs_width = _vs_x;                                           \
	   _vs_IS = _vs_p->base[0]->IS;                                 \
        } else {                                                        \
 	   _vs_num = 1; _vs_IS = 0; _vs_c = 0;                          \
	}                                                               \
        _vs_point = _vs_IS;                                             \
        for(int _vs_i=0;_vs_i<_vs_num;_vs_i++){                         \
           for(int lx=_vs_point;lx<_vs_point+_vs_width; lx++)


// ̤бդʥեƤ
#define para_end1()							\
	   }                                                            \
           _vs_point += 2*_vs_c + _vs_width;                            \
        }

//#define parallel2(lx, ly)						  \
  {									  \
     int _vs_heigh = 0;						          \
     int _vs_old_heigh = 0;                                               \
     int _vs_heigh_flag = 0;                                              \
     int _vs_width = _vs_p->base[1]->local->width;			  \
\
     int ly	      = _vs_p->base[1]->cache[0];		          \
     int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		          \
     vs_StartEnd *_vs_se = new vs_StartEnd[exec_info.div_num];            \
     pthread_t *_vs_tid = new pthread_t[exec_info.div_num];               \
     pthread_setconcurrency(3);                                           \
     int _vs_num=0;                                                       \
     /*_vs_p->base[1]->cache[1] = 1;*/\
     /*fprintf(stderr,"c=%d\n",_vs_p->base[1]->cache[1]);*/ \
     for(;;) {							          \
\
        Pthread_mutex_lock(&exec_info.lock);			          \
	_vs_heigh = _vs_p->base[1]->local->heigh;			  \
	Pthread_mutex_unlock(&exec_info.lock);			          \
\
	if(_vs_heigh == _vs_flag) _vs_flag = 0;			          \
        if(_vs_heigh != _vs_old_heigh){ \
           _vs_old_heigh = _vs_heigh;   \
           _vs_heigh_flag = 1;          \
        }                               \
\
	int width = _vs_width - _vs_p->base[1]->cache[2] 		  \
	                  - _vs_p->base[1]->cache[3];		          \
        int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 		  \
	                  - _vs_p->base[1]->cache[1];		          \
        if(_vs_heigh_flag || _vs_flag == 0){                              \
           /*⤵ѲäƼäƤʤ*/             \
           _vs_heigh_flag = 0;                                            \
           _vs_se[_vs_num].sy = ly;                                       \
           if(_vs_flag == 0){ /*⤵ˤ*/                          \
              _vs_se[_vs_num].ey = (_vs_heigh/exec_info.div_num)*(_vs_num+1);\
           } else {                                                       \
              _vs_se[_vs_num].ey = (_vs_flag/exec_info.div_num)*(_vs_num+1);\
           }                                                              \
           if(_vs_num+1 == exec_info.div_num){/*ǸΤ*/                \
              _vs_se[_vs_num].ey = _vs_heigh - _vs_p->base[1]->cache[1];  \
              /*_vs_se[_vs_num].ey = 1200-64;*/\
           }                                                              \
           ly = _vs_se[_vs_num].ey;                                       \
           _vs_se[_vs_num].sx = _vs_p->base[1]->cache[2];                 \
           _vs_se[_vs_num].ex = _vs_width - _vs_p->base[1]->cache[3];     \
           /*fprintf(stderr,"in parallel\n");*/                           \
 /*fprintf(stderr,"num=%d,sx=%d,ex=%d,sy=%d,ey=%d\n",_vs_num,_vs_se[_vs_num].sx,_vs_se[_vs_num].ex,_vs_se[_vs_num].sy,_vs_se[_vs_num].ey);*/\
           if(_vs_se[_vs_num].sy < _vs_se[_vs_num].ey)

//#define para_end2()	  	                        \
           _vs_num++;                                            \
           }\
        }/*桼դparallelʸƬ{ */            \
	if((!(_vs_flag))&&(_vs_num==exec_info.div_num)) break;      \
     } /* for(;;) */                                                 \
     for(int _vs_i=0;_vs_i<exec_info.div_num;_vs_i++){               \
        /*fprintf(stderr,"wait finish %d\n",_vs_tid[_vs_i]);*/   \
        Pthread_join(_vs_tid[_vs_i], NULL);                         \
        /*fprintf(stderr,"join thread %d\n",_vs_tid[_vs_i]);*/\
     }

#define parallel2(lx, ly)					\
  {								\
    int _vs_heigh = 0;						\
    int _vs_width = _vs_p->base[1]->local->width;		\
\
    int ly	      = _vs_p->base[1]->cache[0];		\
    int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		\
    int _vs_thrflag = (_vs_flag/exec_info.div_num)*(*_vs_id+1); \
    int *_vs_tmp;                                               \
    int _vs_x = _vs_p->base[1]->div_hint.x_divide;                     \
    int _vs_n = _vs_p->base[1]->orig->width/(_vs_x*exec_info.host_num);\
    vs_StartEnd _vs_se;                                         \
    _vs_se.sx = _vs_p->base[1]->cache[2];                       \
    _vs_se.ex = _vs_width - _vs_p->base[1]->cache[3];           \
    if(*_vs_id == 0) _vs_se.sy = ly;                             \
    else _vs_se.sy = (_vs_flag/exec_info.div_num)*(*_vs_id);     \
    if(*_vs_id+1 == exec_info.div_num){                          \
      _vs_se.ey = _vs_flag - _vs_p->base[1]->cache[1];          \
    } else {                                                    \
      _vs_se.ey = (_vs_flag/exec_info.div_num)*(*_vs_id+1);     \
    }                                                           \
    ly = _vs_se.sy;                                             \
    fprintf(stderr,"num=%d,sx=%d,ex=%d,sy=%d,ey=%d\n",*_vs_id,_vs_se.sx,_vs_se.ex,_vs_se.sy,_vs_se.ey);    \
      for(;;) {							\
\
        Pthread_mutex_lock(&exec_info.lock);			\
	_vs_heigh = _vs_p->base[1]->local->heigh;		\
	Pthread_mutex_unlock(&exec_info.lock);			\
\
	if(_vs_heigh >= _vs_thrflag) _vs_flag = 0;		\
        if(_vs_heigh == _vs_flag) _vs_flag = 0;\
        /*fprintf(stderr,"now height = %d\n",_vs_heigh);*/\
	int width = _vs_width - _vs_p->base[1]->cache[2] 	\
	            - _vs_p->base[1]->cache[3];		        \
        int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 	\
	            - _vs_p->base[1]->cache[1];		        \
        if(ly <= _vs_heigh - _vs_p->base[1]->cache[1]){         \
	  for(; ly < _vs_se.ey; ly++) {	                        \
            /*_vs_tmp = _vs_p->base[1]->index;*/                    \
            /*for(int _vs_i=0;_vs_i<_vs_n*_vs_x;_vs_i++){*/         \
            /*int lx = _vs_tmp[_vs_i];*/  \
	    for(int lx = _vs_se.sx; lx<_vs_se.ex; lx++)
	

#define para_end2()				\
            /*}*/ \
	    }/*桼դparallelʸƬ{ */\
	  }					\
          if(!(_vs_flag)) break;		\
        }                                       \
      } /* for(;;) */


//#define parallel2(lx, ly)						\
    {									\
	int _vs_heigh = 0;						\
	int _vs_width = _vs_p->base[1]->local->width;			\
\
	int ly	      = _vs_p->base[1]->cache[0];			\
	int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		\
	for(;;) {							\
\
	    Pthread_mutex_lock(&exec_info.lock);			\
	    _vs_heigh = _vs_p->base[1]->local->heigh;			\
	    Pthread_mutex_unlock(&exec_info.lock);			\
\
	    if(_vs_heigh == _vs_flag) _vs_flag = 0;			\
\
	    int width = _vs_width - _vs_p->base[1]->cache[2] 		\
		                  - _vs_p->base[1]->cache[3];		\
            int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 		\
		                  - _vs_p->base[1]->cache[1];		\
	    for(; ly < (_vs_heigh - _vs_p->base[1]->cache[1]); ly++) {	\
		 for(int lx = _vs_p->base[1]->cache[2];			\
		 lx<(_vs_width - _vs_p->base[1]->cache[3]); lx++)
	

//#define para_end2()				\
		}				\
	    }					\
	    if(!(_vs_flag)) break;		\
	    } /* for(;;) */


/*#define parallel2(lx, ly)						\
  {									\
    int _vs_heigh = 0;						        \
    int _vs_width = _vs_p->base[1]->local->width;			\
    int _vs_x,_vs_c,_vs_IS,_vs_point,_vs_num;                           \
    int ly        = _vs_p->base[1]->cache[0];			        \
    int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		        \
    int _vs_flagy = 1;                                                  \
    int *_vs_tmptmp;                                                    \
    for(;;) {							        \
\
      Pthread_mutex_lock(&exec_info.lock);			        \
      _vs_heigh = _vs_p->base[1]->local->heigh;			        \
      Pthread_mutex_unlock(&exec_info.lock);			        \
\
      if(_vs_heigh == _vs_flag) _vs_flag = 0;			        \
\
      int width = _vs_width - _vs_p->base[1]->cache[2] 		        \
		                  - _vs_p->base[1]->cache[3];		\
      int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 		        \
		                  - _vs_p->base[1]->cache[1];		\
       if(_vs_p->base[1]->dtype==dCOLCYC){                              \
         _vs_x = _vs_p->base[1]->div_hint.x_divide;                     \
         _vs_num = _vs_p->base[1]->orig->width/(_vs_x*exec_info.host_num);\
         _vs_c = _vs_p->base[1]->c;                                     \
         _vs_width = _vs_x; _vs_flag = _vs_p->base[1]->orig->heigh;     \
         if(_vs_heigh == _vs_flag) _vs_flag = 0;                        \
         if(_vs_flagy){                                                 \
           ly = 0; _vs_flagy = 0;                                       \
         }                                                              \
         _vs_IS = _vs_p->base[1]->IS;                                   \
       } else {                                                         \
         _vs_num = 1;_vs_IS = _vs_p->base[1]->cache[2];                 \
         _vs_c = 0; _vs_width = _vs_width - _vs_p->base[1]->cache[3];   \
         _vs_heigh = _vs_heigh - _vs_p->base[1]->cache[1];              \
       }                                                                \
       _vs_tmptmp = _vs_p->base[1]->index;                              \
       for(; ly < _vs_heigh; ly++) {	                                \
         _vs_point = _vs_IS;                                            \
         for(int _vs_i=0;_vs_i<_vs_num*_vs_width;_vs_i++){              \
	 int lx = _vs_tmptmp[_vs_i];          */

	

/*#define para_end2()				\
	   }     				\
           _vs_point += 2*_vs_c + _vs_width;    \
	 }					\
       }                                        \
       if(!(_vs_flag)) break;		        \
       } *//* for(;;) */


#define parallel3(lx, ly, lz)						\
   {									\
      int _vs_depth = 0;						\
      int _vs_heigh = _vs_p->base[2]->local->heigh;			\
      int _vs_width = _vs_p->base[2]->local->width;			\
\
      int lz        = _vs_p->base[2]->cache[4];			         \
      int _vs_flag  = _vs_p->base[2]->dsize / (_vs_width * _vs_heigh);   \
      vs_StartEnd *_vs_se = new vs_StartEnd[exec_info.div_num];          \
      pthread_t *_vs_tid = new pthread_t[exec_info.div_num];             \
      pthread_setconcurrency(3);                                         \
      int _vs_num=0;                                                     \
\
      for(;;) {							\
         Pthread_mutex_lock(&exec_info.lock);			\
	 _vs_depth = _vs_p->base[2]->local->depth;			\
	 Pthread_mutex_unlock(&exec_info.lock);			\
\
	 if(_vs_depth == _vs_flag) _vs_flag = 0;			\
\
	 int width = _vs_width - _vs_p->base[2]->cache[2] 		\
		                  - _vs_p->base[2]->cache[3];		\
         int heigh = _vs_heigh - _vs_p->base[2]->cache[0] 		\
		                  - _vs_p->base[2]->cache[1];		\
         int depth = _vs_depth - _vs_p->base[2]->cache[4] 		\
		                  - _vs_p->base[2]->cache[5];		\
         if(_vs_flag==0){/* äƤ롣ĤޤǸΤ */     \
            if(_vs_num == 0){ /* div_num = 0 */                         \
            } else { /* ʬ䤷ƤơǸΤ */                       \
            }                                                           \
         } else {/* Τ */                                       \
            _vs_se[_vs_num].sz = lz;                                    \
            lz = _vs_depth;                                             \
            _vs_se[_vs_num].ez = _vs_depth - _vs_p->base[2]->cache[5];  \
         }                                                              \
         for(; lz < (_vs_depth - _vs_p->base[2]->cache[5]); lz++) {	\
         _vs_se[_vs_num].sy = _vs_p->base[2]->cache[0];                 \
         _vs_se[_vs_num].ey = _vs_heigh - _vs_p->base[2]->cache[1];     \
         _vs_se[_vs_num].sx = _vs_p->base[2]->cache[2];                 \
         _vs_se[_vs_num].ex = _vs_width - _vs_p->base[2]->cache[3];     \
         if(_vs_se[_vs_num].sz < _vs_se[_vs_num].ez)
	 


#define para_end3()							\
	    _vs_num++;   						\
	 }/*桼դparallelʸƬ{ */  		\
	 if((!(_vs_flag))&&(_vs_num==exec_info.div_num)) break; 	\
      }   /* for(;;) */                                                 \
      for(int _vs_i=0;_vs_i<exec_info.div_num;_vs_i++){                 \
        fprintf(stderr,"wait finish %d\n",_vs_tid[_vs_i]);              \
        Pthread_join(_vs_tid[_vs_i], NULL);                             \
        fprintf(stderr,"join thread %d\n",_vs_tid[_vs_i]);              \
      }


/*#define parallel3(lx, ly, lz)						\
    {									\
	int _vs_depth = 0;						\
	int _vs_heigh = _vs_p->base[2]->local->heigh;			\
	int _vs_width = _vs_p->base[2]->local->width;			\
\
	int lz        = _vs_p->base[2]->cache[4];			\
	int _vs_flag  = _vs_p->base[2]->dsize / (_vs_width * _vs_heigh);\
\
	for(;;) {							\
	    Pthread_mutex_lock(&exec_info.lock);			\
	    _vs_depth = _vs_p->base[2]->local->depth;			\
	    Pthread_mutex_unlock(&exec_info.lock);			\
\
	    if(_vs_depth == _vs_flag) _vs_flag = 0;			\
\
	    int width = _vs_width - _vs_p->base[2]->cache[2] 		\
		                  - _vs_p->base[2]->cache[3];		\
            int heigh = _vs_heigh - _vs_p->base[2]->cache[0] 		\
		                  - _vs_p->base[2]->cache[1];		\
            int depth = _vs_depth - _vs_p->base[2]->cache[4] 		\
		                  - _vs_p->base[2]->cache[5];		\
	    for(; lz < (_vs_depth - _vs_p->base[2]->cache[5]); lz++) {	\
		for(int ly = _vs_p->base[2]->cache[0]; \
		    ly < (_vs_heigh - _vs_p->base[2]->cache[1]); ly++) {\
		    for(int lx = _vs_p->base[2]->cache[2]; \
		    lx < (_vs_width - _vs_p->base[2]->cache[3]); lx++)*/


/*#define para_end3()							\
	        	}						\
		}							\
	    }								\
	    if(!(_vs_flag)) break;					\
	    }*/   /* for(;;) */




// I/Eǽդparallelʸ ---------------------------------------------

#define parallel1_ie(lx)       						\
    {									\
        int _vs_width = 0;						\
        Pthread_mutex_lock(&exec_info.lock);				\
	_vs_width = _vs_p->base[0]->local->width;			\
        Pthread_mutex_unlock(&exec_info.lock);				\
\
        int width = _vs_width - _vs_p->base[0]->cache[2] 		\
		              - _vs_p->base[0]->cache[3];		\
	vsSync();							\
\
	_vs_p->isWait = 0;						\
	for(int lx = 0; lx < _vs_width; lx++) {				\
	    /* Inspector */

#define parallel1_ie2(lx)						\
	    if(_vs_p->isWait) {						\
	        _vs_p->q->push(lx);					\
		ip->GetReq();						\
		_vs_p->isWait = 0;					\
		continue;						\
	    }								\
	    /* Executorμ¹ */

#define parallel1_ie3(lx)						\
	}   /* forʸνλ */						\
\
	_vs_p->isWait = 0;						\
        while(_vs_p->q->count) {					\
	    int lx;							\
	    _vs_p->q->pop(&lx);						\
	    /* Inspector */

#define parallel1_ie4(lx)	parallel1_ie2(lx)


#define para_end_ie()							\
	}								\
	for(int i=0; i<exec_info.host_num; i++) {			\
\
	    if(_vs_p->io_buf[i] != NULL) {				\
		vs_io_buf* ptr1 = _vs_p->io_buf[i];			\
		vs_io_buf* ptr2 =  ptr1->next;				\
\
		while(ptr2 != NULL) {					\
		    delete ptr1; ptr1 = ptr2; ptr2 = ptr1->next;	\
		}							\
		delete ptr1;						\
	        _vs_p->io_buf[i] = NULL;				\
	    }								\
	}								\
    }



#define parallel2_ie(lx, ly)						\
    {									\
	int _vs_width = _vs_p->base[1]->local->width;			\
	int _vs_heigh;							\
	int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		\
\
\
	Pthread_mutex_lock(&exec_info.lock);				\
	_vs_heigh = _vs_p->base[1]->local->heigh;			\
	if(_vs_heigh != _vs_flag)					\
	    Pthread_cond_wait(&exec_info.cond, &exec_info.lock);	\
	Pthread_mutex_unlock(&exec_info.lock);				\
\
	int width = _vs_width - _vs_p->base[1]->cache[2] 		\
		              - _vs_p->base[1]->cache[3];		\
        int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 		\
		              - _vs_p->base[1]->cache[1];		\
\
	vsSync();							\
	_vs_p->isWait = 0;						\
	for(int ly = _vs_p->base[1]->cache[0]; \
	    ly < (_vs_heigh - _vs_p->base[1]->cache[1]); ly++)		\
	       for(int lx = _vs_p->base[1]->cache[2];			\
		   lx<(_vs_width - _vs_p->base[1]->cache[3]); lx++) {   \
	    /* Inspector */


#define parallel2_ie2(lx, ly)						\
            if(_vs_p->isWait) {						\
	        _vs_p->q->push(lx, ly);					\
		ip->GetReq();						\
		_vs_p->isWait = 0;					\
		continue;						\
	    }								\
	    /* Executorμ¹ */


#define parallel2_ie3(lx, ly)						\
	}   /* forʸνλ */						\
\
        _vs_p->isWait = 0;						\
        while(_vs_p->q->count) {					\
	    int lx, ly;							\
	    _vs_p->q->pop(&lx, &ly);					\
	    /* Inspector */


#define parallel2_ie4(lx, ly)	parallel2_ie2(lx, ly)





// BoxʬΤparallelʸ ---------------------------------------------

#define parallel1_box(cut_x, lx)					\
    {									\
	int _vs_width = 0;						\
        Pthread_mutex_lock(&exec_info.lock);				\
	_vs_width = _vs_p->base[0]->local->width;			\
        Pthread_mutex_unlock(&exec_info.lock);				\
\
        int width = _vs_width - _vs_p->base[0]->cache[2] 		\
		              - _vs_p->base[0]->cache[3];		\
\
	for(int lx = _vs_p->base[0]->cache[2];				\
		  lx<(_vs_width - _vs_p->base[0]->cache[3]); lx+=cut_x)

#define parallel2_box(cut_x, cut_y, lx, ly)				\
  {									\
     int _vs_heigh = 0;					        	\
     int _vs_width = _vs_p->base[1]->local->width;			\
\
     int ly	      = _vs_p->base[1]->cache[0];			\
     int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		        \
     vs_StartEnd *_vs_se = new vs_StartEnd[exec_info.div_num];          \
     pthread_t *_vs_tid = new pthread_t[exec_info.div_num];             \
     pthread_setconcurrency(3);                                         \
     int _vs_num=0;                                                     \
     for(;;) {							        \
\
        Pthread_mutex_lock(&exec_info.lock);			        \
	_vs_heigh = _vs_p->base[1]->local->heigh;			\
	Pthread_mutex_unlock(&exec_info.lock);			        \
\
	if(_vs_heigh == _vs_flag) _vs_flag = 0;			        \
\
	int width = _vs_width - _vs_p->base[1]->cache[2] 		\
	               - _vs_p->base[1]->cache[3];		        \
        int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 		\
	               - _vs_p->base[1]->cache[1];		        \
         if(_vs_flag==0){/* äƤ롣ĤޤǸΤ */       \
           if(_vs_num == 0){ /* div_num = 0 */                            \
              _vs_se[0].sy = ly;                                          \
              /*fprintf(stderr,"ly=%d\n",ly);*/                           \
              _vs_se[0].ey = _vs_heigh - _vs_p->base[1]->cache[1];        \
           } else {/* ʬ䤷ƤơǸΤ */                           \
              _vs_se[_vs_num].sy = ly;                                    \
              /*fprintf(stderr,"c=%d\n",_vs_p->base[1]->cache[1]);*/ \
              _vs_se[_vs_num].ey = _vs_heigh - _vs_p->base[1]->cache[1];  \
              /*_vs_se[_vs_num].ey = _vs_heigh - 64;*/  \
           }                                                              \
        } else {/* Τ */                                          \
           _vs_se[_vs_num].sy = ly;                                       \
           if(_vs_heigh > (_vs_flag/exec_info.div_num)*(_vs_num+1)){      \
              _vs_se[_vs_num].ey = (_vs_flag/exec_info.div_num)*(_vs_num+1);\
              ly = _vs_se[_vs_num].ey;                                    \
           }                                                              \
        }                                                                 \
        _vs_se[_vs_num].sx = _vs_p->base[1]->cache[2];                    \
        _vs_se[_vs_num].ex = _vs_width - _vs_p->base[1]->cache[3];        \
        /*fprintf(stderr,"in parallel\n");*/                              \
        if(_vs_se[_vs_num].sy < _vs_se[_vs_num].ey)


/*#define parallel2_box(cut_x, cut_y, lx, ly)				\
    {									\
	int _vs_heigh = 0;						\
	int _vs_width = _vs_p->base[1]->local->width;			\
\
	int ly	      = _vs_p->base[1]->cache[0];			\
	int _vs_flag  = _vs_p->base[1]->dsize / _vs_width;		\
	for(;;) {							\
\
	    Pthread_mutex_lock(&exec_info.lock);			\
	    _vs_heigh = _vs_p->base[1]->local->heigh;			\
	    Pthread_mutex_unlock(&exec_info.lock);			\
\
	    if(_vs_heigh == _vs_flag) _vs_flag = 0;			\
\
	    int width = _vs_width - _vs_p->base[1]->cache[2] 		\
		                  - _vs_p->base[1]->cache[3];		\
            int heigh = _vs_heigh - _vs_p->base[1]->cache[0] 		\
		                  - _vs_p->base[1]->cache[1];		\
	    for(; ly < (_vs_heigh - _vs_p->base[1]->cache[1]); ly+=cut_y) { \
		 for(int lx = _vs_p->base[1]->cache[2];			    \
		 lx<(_vs_width - _vs_p->base[1]->cache[3]); lx+=cut_x)*/
	


#define parallel3_box(cut_x, cut_y, cut_z, lx, ly, lz)			\
    {									\
	int _vs_depth = 0;						\
	int _vs_heigh = _vs_p->base[2]->local->heigh;			\
	int _vs_width = _vs_p->base[2]->local->width;			\
\
	int lz        = _vs_p->base[2]->cache[4];			\
	int _vs_flag  = _vs_p->base[2]->dsize / (_vs_width * _vs_heigh);\
\
	for(;;) {							\
	    Pthread_mutex_lock(&exec_info.lock);			\
	    _vs_depth = _vs_p->base[2]->local->depth;			\
	    Pthread_mutex_unlock(&exec_info.lock);			\
\
	    if(_vs_depth == _vs_flag) _vs_flag = 0;			\
\
	    int width = _vs_width - _vs_p->base[2]->cache[2] 		\
		                  - _vs_p->base[2]->cache[3];		\
            int heigh = _vs_heigh - _vs_p->base[2]->cache[0] 		\
		                  - _vs_p->base[2]->cache[1];		\
            int depth = _vs_depth - _vs_p->base[2]->cache[4] 		\
		                  - _vs_p->base[2]->cache[5];		\
	    for(; lz < (_vs_depth - _vs_p->base[2]->cache[5]); lz++) {	\
		for(int ly = _vs_p->base[2]->cache[0]; \
		    ly < (_vs_heigh - _vs_p->base[2]->cache[1]); ly++) {\
		    for(int lx = _vs_p->base[2]->cache[2]; \
			lx < (_vs_width - _vs_p->base[2]->cache[3]); lx++)

#endif
