/**********************************************************
  vsvalue.h
  VIOS 1󥯥饹
***********************************************************/
#include "module.h"
#include "ip.h"

#ifndef __VS_VALUE_H
#define __VS_VALUE_H

template <class T>
class vsvalue
{
  protected:
    int		lx;

    int		w_chk;

    // ۵ѡ̾parallelʸǤ㳰
    vs_request	req;

    T		GetNow(int x);
    // ٱѡI/EparallelʸǤɡ
    int		b_width;

    int*	host_cnt;
    int*	wait_cnt;
    vs_io_buf**	  io_buf;
    vs_reqgrp*	send_buf;

    T		GetReq(int x);
    T		SetReq(T val);

    // ֽ񤭹ѡ㳰Ū
    vs_write	wbuf;

  public:
    int		id;

    vs_data*	info;
    T*		dt;

     vsvalue();
     vsvalue(int width,            int def = 0);
     vsvalue(vsvalue<int>*   orig, int def);
     vsvalue(vsvalue<FLOAT>* orig, int def);
    ~vsvalue();

#define _VS_OPERATE_1D(OP) 			\
    if(w_chk) dt[lx] OP val;			\
    else SetReq(val);				\
    return val;

    inline T operator  =(T val){ _VS_OPERATE_1D (=)  };
    inline T operator +=(T val){ _VS_OPERATE_1D (+=) };
    inline T operator -=(T val){ _VS_OPERATE_1D (-=) };
    inline T operator *=(T val){ _VS_OPERATE_1D (*=) };
    inline T operator /=(T val){ _VS_OPERATE_1D (/=) };

#undef _VS_OPERATE_1D

    inline T vs_ck (int x)
           {    return ((x >= 0) && (x < info->local->width))? \
		                              dt[x] : GetReq(x);   };
    inline T vs_rd (int x)
           {    return ((x >= 0) && (x < info->local->width))? \
		                              dt[x] : GetNow(x);   };
    inline T vs_rde(int x)
           {    return ((x >= 0) && (x < info->local->width))? \
		                              dt[x] : GetReq(x);   };
    inline T vs_rdc(int x)
            {   return dt[x];                                      };

    inline vsvalue& vs_wt (int x)
            {   w_chk = ((x >= 0) && (x < info->local->width))? 1:0;
		if(w_chk == 0) {
		    fprintf(stderr,"x is %d, width is %d\n",x,\
			    info->local->width);
		    w_chk = 1;
		}
		lx = x; return *this;
	    };
    inline vsvalue& vs_wte(int x)
            {   w_chk = ((x >= 0) && (x < info->local->width))? 1:0;
		lx = x; return *this;
	    };
    inline vsvalue& vs_wtc(int x)
            {   w_chk = 1; lx = x; return *this;
	    };

    inline vsvalue& vs_rw (int x)
            {   w_chk = ((x >= 0) && (x < info->local->width))? 1:0;
		lx = x; return *this;
	    };
    inline vsvalue& vs_rwe(int x)
            {   w_chk = ((x >= 0) && (x < info->local->width))? 1:0;
		lx = x; return *this;
	    };
    inline vsvalue& vs_rwc(int x)
            {   w_chk = 1; lx = x; return *this;
	    };


    void	ValCopy(vsvalue<int>*	src);
    void	ValCopy(vsvalue<FLOAT>* src);
};


#include "vsvalue_const.h"
#include "vsvalue_comm.h"

#endif
