%{
FILE * yycfile;
%}
%x START VIOS DEF
ND  [a-zA-Z_]
DG  [0-9]

%%
^"#line"        fprintf(yycfile,"#line");
^"#"            fprintf(yycfile,"#");
"vs_module"    fprintf(yycfile,"%s",yytext); BEGIN START;
\n              fprintf(yycfile,"\n");
.		fprintf(yycfile,"%c",yytext[0]);

<START>"("      fprintf(yycfile,"(int *_vs_id");
<START>"{"      {
                   fprintf(yycfile,"%c\n\t",yytext[0]);
                   fprintf(yycfile,"Pthread_mutex_lock(&exec_info.lock);");
                   BEGIN VIOS;
                }
<START>\n       fprintf(yycfile,"\n");
<START>.        fprintf(yycfile,"%c",yytext[0]);

<VIOS>"ivalue"	   fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"fvalue"	   fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"ivalue_opt" fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"fvalue_opt" fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"iImage"	   fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"fImage"	   fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"iImage_opt" fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"fImage_opt" fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"iCube"	   fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"fCube"	   fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"iCube_opt"  fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>"fCube_opt"  fprintf(yycfile,"%s",yytext); BEGIN DEF;
<VIOS>\n	   fprintf(yycfile,"\n");
<VIOS>[ ]	   fprintf(yycfile,"\n");
<VIOS>[\t]	   fprintf(yycfile,"\n");
<VIOS>.		   {
                     fprintf(yycfile,"module_tab.mod_cnt = 0;\n"
		             "Pthread_mutex_unlock(&exec_info.lock);\n");
		     BEGIN INITIAL;
		     fprintf(yycfile,"%c",yytext[0]);
                   }

<DEF>\n            fprintf(yycfile,"\n"); BEGIN VIOS;
<DEF>.             fprintf(yycfile,"%c",yytext[0]);


%%
/*
 $B%W%m%0%i%`It(B
*/
int main(int argc, char* argv[]){
    
    if(argc != 3){
      fprintf(stderr,"usage: %s module cfile\n",argv[0]);
      return(1);
    }
    if(!(yyin = fopen(argv[1],"r"))){
      fprintf(stderr,"Cannot open file:%s",argv[1]);
      return(1);
    }
    if(!(yycfile = fopen(argv[2],"w"))){
      fprintf(stderr,"file open error:%s",argv[2]);
      return(1);
    }

    while(yylex());
    
    fclose(yyin);
    fclose(yycfile);
    return(0);
}
