/********************************************************************
  ip_recv.cc
    OM <=> IP ̿
*********************************************************************/
#include <sys/types.h>
#include <sys/socket.h>

#include "ip.h"
#include "ip_table.h"
#include "module.h"


Ip::Ip(int fd)
{
    om_fd    = fd;
    conn_num = 0;
    sync_cnt = 0;

    // Ѵؿݥ󥿤ν
    Recv[pConnReq]		= &Ip::ReqConnectStart;
    Recv[pInterConn]		= &Ip::ReqInterConnect;
    Recv[pModule]		= &Ip::ReqModule;

    Recv[pReqImg]		= &Ip::RecvImg;
    Recv[pReqCub]		= &Ip::RecvCub;
    Recv[pReqValue]		= &Ip::RecvValue;
    Recv[pReqImgCyc]            = &Ip::RecvImgCyc; //ɲ
    Recv[pReqCubCyc]            = &Ip::RecvCubCyc; //ɲ
    Recv[pReqValueCyc]          = &Ip::RecvValueCyc; //ɲ

    Recv[pEnd]			= &Ip::ReqEnd;
    Recv[pSync]			= &Ip::ReqSync;
    Recv[pUnion]		= &Ip::ReqUnion;
    Recv[pInfo]			= &Ip::ReqInfo;
    Recv[pGather]		= &Ip::ReqGather;


    // ip<->ipμؿ
    RecvIP[pReqSet]		= &Ip::ReqSet;
    RecvIP[pRetComm]		= &Ip::RetComm;

    RecvIP[pReqCell]		= &Ip::ReqCell;
    RecvIP[pRetCell]		= &Ip::RetCell;

    RecvIP[pReqCell_nw]		= &Ip::ReqCell_nw;
    RecvIP[pRetCell_nw]		= &Ip::RetCell_nw;

    RecvIP[pReqSyncCache]	= &Ip::ReqCache;
    RecvIP[pRetSyncCache]	= &Ip::RetCache;

}


/* -------------------------------------------------------- */
/* ----------------  ³ؿ(Select)  ---------------- */
void
Ip::ConnectStart()
{
    fd_set   fds1;
    FD_ZERO(&fds1); FD_SET(om_fd, &fds1);

    int protocol;
    for(;;) {
	Select(om_fd+1, &fds1, NULL, NULL, NULL);

	Readn(om_fd, (void*)&protocol, sizeof(int));

	//fprintf(stderr,"       recv request:%d\n",protocol);
	//timeval st, et;
	//Gettimeofday(&st, NULL);

	(this->*Ip::Recv[protocol])();
	//fprintf(stderr,"     finish request:%d\n",protocol);
	//Gettimeofday(&et, NULL);
	//double t = et.tv_sec - st.tv_sec + \
	//  (et.tv_usec - st.tv_usec) * 0.000001;
	//fprintf(stderr,"   communication time: %1.4lf\n", t);
    }
}

void
Ip::InterConnect1()
{

    fd_set	fds;
    FD_ZERO(&fds);
    int host   = exec_info.host_num;


    int	waitfd = 0;
    for(int i=0; i<host; i++) {
	if(i != id) {
	    FD_SET(readfd[i], &fds);
	    if(readfd[i] > waitfd) waitfd = readfd[i];
	}
    }
    waitfd++;

    int protocol;
    for(;;) {
	Select(waitfd, &fds, NULL, NULL, NULL);

	for(int i=0; i<host; i++) {
	    if((i != id) && (FD_ISSET(readfd[i],&fds))) {
		Readn(readfd[i], (void*)&protocol, sizeof(int));
		(this->*Ip::RecvIP[protocol])(i);
	    }
	    FD_SET(readfd[i], &fds);
	}
    }
}

void
Ip::InterConnect2()
{

    fd_set	fds;
    FD_ZERO(&fds);
    int host   = exec_info.host_num;

    int	waitfd = 0;
    for(int i=0; i<host; i++) {
	if(i != id) {
	    FD_SET(wrtefd[i], &fds);
	    if(wrtefd[i] > waitfd) waitfd = wrtefd[i];
	}
    }
    waitfd++;

    int protocol;
    for(;;) {
	Select(waitfd, &fds, NULL, NULL, NULL);

	for(int i=0; i<host; i++) {
	    if((i != id) && (FD_ISSET(wrtefd[i],&fds))) {
		Readn(wrtefd[i], (void*)&protocol, sizeof(int));
		(this->*Ip::RecvIP[protocol])(i);
	    }
	    FD_SET(wrtefd[i], &fds);
	}
    }
}

//  ip³ϴؿOMidꤲ -----------------


extern "C" {

// threadΤΥåѴؿ
void*
WrapInterConnect1(){    (ip->InterConnect1)(); return NULL;    }
void*
WrapInterConnect2(){    (ip->InterConnect2)(); return NULL;    }

}	// extern "C"

void
Ip::ReqConnectStart()
{
     // ݡֹNULL
    socklen_t addrlen;
#ifndef __linux__     //for solaris
    int	listenfd = Tcp_listen(exec_info.ip[id].name, NULL, &addrlen);
#else                 //for linux
    int	listenfd = Tcp_listen(exec_info.ip[id].name, vsPORT2, &addrlen);
#endif

    // ǳݡȤξOMͳۤäƤ餦
    sockaddr_in addr;
    Getsockname(listenfd, (sockaddr*)&addr, &addrlen);
    Writen(om_fd, (void*)&addr.sin_port, sizeof(in_port_t));

    // պ
    int host;
    for(int i=1; i < (exec_info.host_num - id) * 2 -1; i++) {
	int fd = Accept(listenfd, NULL, &addrlen);

	Readn(fd, (void*)&host, sizeof(int));
	if(host > 0) {
	    readfd[host]  = fd;
	} else {
	    wrtefd[-host] = fd;
	    ++conn_num;
	}
    }

    readfd[id] = 2; wrtefd[id] = 2;
    if(conn_num == exec_info.host_num -1) {
	// OMؤޤǡˤ1ĤLWP餻
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

	Pthread_create(&conn_id1, &attr, \
		       (void*(*)(void*))&WrapInterConnect1, NULL);
	Pthread_create(&conn_id2, &attr, \
		       (void*(*)(void*))&WrapInterConnect2, NULL);
    }
}

void
Ip::ReqInterConnect()
{
    int       	other_id;
    in_port_t	port_num;
    Readn(om_fd, (void*)&other_id, sizeof(int));
    Readn(om_fd, (void*)&port_num, sizeof(in_port_t));

    char port[6];
    port_num = htons(port_num);		// Ϥ褦˽
    snprintf(port,6,"%hu", port_num);

    // ¾ipȤ³
    wrtefd[other_id] = Tcp_connect(exec_info.ip[other_id].name, port);
    Writen(wrtefd[other_id], (void*)&id, sizeof(int));

    readfd[other_id] = Tcp_connect(exec_info.ip[other_id].name, port);
    id = -id;
    Writen(readfd[other_id], (void*)&id, sizeof(int));
    id = -id;

    readfd[id] = 2; wrtefd[id] = 2;
    if(++conn_num == exec_info.host_num - 1) {
	pthread_attr_t attr;
	pthread_attr_init(&attr);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

	Pthread_create(&conn_id1, &attr, \
		       (void*(*)(void*))&WrapInterConnect1, NULL);
	Pthread_create(&conn_id2, &attr, \
		       (void*(*)(void*))&WrapInterConnect2, NULL);
    }
}






/* ---------------------------------------------------------------- */
/* -----------------------  OMȤ̿ؿ  ----------------------- */
void
Ip::ReqModule()
{
  // ⥸塼ѥ᡼μ
  Readn(om_fd, (void*)module_tab.name,  MAX_LEN);
  Readn(om_fd, (void*)&module_tab.argc, sizeof(int));
  
  // ޤƥѥ᡼ν  ------------------------
  module_tab.dike 	= 0;
  module_tab.cal_num  = 0;
  module_tab.mod_cnt  = 0;
  module_tab.base[0]  = NULL;
  module_tab.base[1]  = NULL;
  module_tab.base[2]  = NULL;
  bzero(module_tab.io_buf, sizeof(vs_io_buf*) * MAX_IO_BUF);
  bzero(module_tab.comm_q, sizeof(vs_comm_q)  * MAX_COMM_Q);

  // ư˴ؤ  ----------------------------------
  vs_data* tmp;
  for(int j=0; j<module_tab.argc; j++) {
    //fprintf(stderr,"arg %d\n",j);
    tmp = new vs_data;
    Readn(om_fd, (void*)tmp, VS_DATA_SIZE);
    
    tmp->orig = new DimInfo;
    Readn(om_fd, (void*)tmp->orig, sizeof(DimInfo));
    //fprintf(stderr,"w=%d,h=%d,c=%d,\n",tmp->orig->width,tmp->orig->heigh,tmp->orig->cache);
    if(tmp->type & isIMG) {			// 2ǡФ
      if((tmp->dtype==dCOLCYC)||(tmp->dtype==dROWCYC)){//åʤ顣ɲ
	// ΤȤʤˤ館Τ狼ʤ
	//fprintf(stderr,"Divide type is Cyclic\n");
	//fprintf(stderr,"Recv nothing\n");
	tmp->div_info = new DivInfo[2];
	Readn(om_fd, tmp->div_info, sizeof(DivInfo) * 2);
	//fprintf(stderr,"index x =%d,y=%d\n",tmp->div_info[0].index,tmp->div_info[1].index);
      }else{
	if(tmp->dtype != dALL){
	  tmp->div_info = new DivInfo[exec_info.div_num + 1];
	  Readn(om_fd, tmp->div_info, \
		(exec_info.div_num + 1) * sizeof(DivInfo));
	} else {
	  tmp->div_info = new DivInfo[2];
	  Readn(om_fd, tmp->div_info, sizeof(DivInfo) * 2);
	}
      }
    }
    else if(tmp->type & isCUB) {		// 3ǡФ
      
      if(tmp->dtype != dALL) {
	tmp->div_info = new DivInfo[exec_info.div_num + 2];
	
	Readn(om_fd, tmp->div_info, \
	      (exec_info.div_num + 2) * sizeof(DivInfo));
      } else {
	tmp->div_info = new DivInfo[3];
	Readn(om_fd, tmp->div_info, sizeof(DivInfo) * 3);
      }
    }
    else {					// 1ǡФ
      if(tmp->dtype == dCOLCYC){ // åʬʤ顣ɲ
	tmp->div_info = new DivInfo;
	Readn(om_fd, tmp->div_info, sizeof(DivInfo));
      } else {
	// ߤνꡤʬˤбƤʤ
	tmp->div_info = new DivInfo;
	Readn(om_fd, tmp->div_info, sizeof(DivInfo));
      }
    }
    
    // ѿϿԤ ----------------------------------------
    module_tab.argv[j] = ip_table.regist(tmp);
    // åΰθ
    if((tmp->dtype==dCOLCYC)||(tmp->dtype==dROWCYC)){
      // ΤȤ館ΤʤΤǰŪ˲
      //fprintf(stderr,"cyclic cache check\n");
      bzero(tmp->cache, sizeof(int) * 6);
      //fprintf(stderr,"c0=%d,c1=%d,c2=%d,c3=%d\n",tmp->cache[0],tmp->cache[1],tmp->cache[2],tmp->cache[3]);
      //module_tab.dike = 1;
    } else {
      // åʤʤ麣ޤǤɤꡣ
      SetDike(0, module_tab.argv[j]);
    }
    // parallel١Ͽ
    if(module_tab.argv[j]->type & isIMG) {
      if(module_tab.base[1] == NULL) {
	module_tab.base[1] = module_tab.argv[j];

	if((module_tab.base[1]->dtype == dCOLCYC)||
	   (module_tab.base[1]->dtype == dROWCYC)){
	  // åʤ顣ɬס1˺줺ľޤ礦
	  //fprintf(stderr,"cyclic parallel base\n");
	  //fprintf(stderr,"w=%d,h=%d,c=%d,dsize=%d\n",module_tab.base[1]->local->width,module_tab.base[1]->local->heigh,module_tab.base[1]->cache[0],module_tab.base[1]->dsize);
	  //base2D[0] = 4;
	  //base2D[1] = 8;
	} else {
	  // comm̿Ѥ  ---------------
	  int b_remain;
	  vs_data* info = module_tab.base[1];
	  
	  b_remain = info->orig->width % info->div_hint.x_divide;
	  if(b_remain)
	    b_remain  = info->div_hint.x_divide - b_remain;
	  base2D[0] = (info->orig->width + b_remain) / \
	    info->div_hint.x_divide;
	  
	  
	  b_remain = info->orig->heigh % info->div_hint.y_divide;
	  if(b_remain)
	    b_remain  = info->div_hint.y_divide - b_remain;
	  base2D[1]  = (info->orig->heigh + b_remain) / \
	    info->div_hint.y_divide;
	  //fprintf(stderr,"base0=%d,base1=%d\n",base2D[0],base2D[1]);
	}
      }
    }
    else if(module_tab.argv[j]->type & isCUB) {
      if(module_tab.base[2] == NULL) {
	module_tab.base[2] = module_tab.argv[j];
	
	// comm̿Ѥ  ---------------
	int b_remain;
	vs_data* info = module_tab.base[2];
	
	b_remain = info->orig->width % info->div_hint.x_divide;
	if(b_remain)
	  b_remain  = info->div_hint.x_divide - b_remain;
	base3D[0] = (info->orig->width + b_remain) / \
	  info->div_hint.x_divide;
	
	
	b_remain = info->orig->heigh % info->div_hint.y_divide;
	if(b_remain)
	  b_remain  = info->div_hint.y_divide - b_remain;
	base3D[1]  = (info->orig->heigh + b_remain) / \
	  info->div_hint.y_divide;
	
	b_remain = info->orig->depth % info->div_hint.z_divide;
	if(b_remain)
	  b_remain  = info->div_hint.z_divide - b_remain;
	base3D[2]  = (info->orig->depth + b_remain) / \
	  info->div_hint.z_divide;
      }
    }
    else {
      if(module_tab.base[0] == NULL) {
	module_tab.base[0] = module_tab.argv[j];
	
	int b_remain;
	vs_data* info = module_tab.base[0];
	
	b_remain = info->orig->width % info->div_hint.x_divide;
	if(b_remain)
	  b_remain  = info->div_hint.x_divide - b_remain;
	base1D = (info->orig->width + b_remain) / \
	  info->div_hint.x_divide;
      }
    }
    
    // ѿϿѤΤ
    //(㤦ʬѥƱǡˤ̤бѿˤɬפ)
    if(module_tab.argv[j] == tmp) {
      if(module_tab.argv[j]->type > MAX_VAR) {
	module_tab.argv[j]->type -= MAX_VAR;	/* Ǹ */
	goto SKIP;
      }
      ++module_tab.cal_num;
      if(tmp->type & isIMG) {
	if((tmp->dtype==dCOLCYC)||(tmp->dtype==dROWCYC)){
	  // åνɲ
	  int protocol = pReqImgCyc;
	  Writen(om_fd, (void*)&protocol, sizeof(int));
	  Writen(om_fd, (void*)&tmp->id, sizeof(int));
	  // ʹߤϤޤ
	}else{
	  int protocol = pReqImg;
	  Writen(om_fd, (void*)&protocol,     sizeof(int));
	  Writen(om_fd, (void*)&tmp->id,	    sizeof(int));
	  Writen(om_fd, (void*)&tmp->div_info[0], sizeof(DivInfo));
	  Writen(om_fd, (void*)&tmp->div_info[1], sizeof(DivInfo));
	}
      }
      else if(tmp->type & isCUB) {
	int protocol = pReqCub;
	Writen(om_fd, (void*)&protocol,     sizeof(int));
	Writen(om_fd, (void*)&tmp->id,      sizeof(int));
	Writen(om_fd, (void*)&tmp->div_info[0], sizeof(DivInfo));
	Writen(om_fd, (void*)&tmp->div_info[1], sizeof(DivInfo));
	Writen(om_fd, (void*)&tmp->div_info[2], sizeof(DivInfo));
      }
      else {
	if(tmp->dtype == dCOLCYC){ //åʬѤνɲ
	  int protocol = pReqValueCyc;
	  //fprintf(stderr,"Send pReqValueCyc\n");
	  Writen(om_fd, (void*)&protocol,     sizeof(int));
	  Writen(om_fd, (void*)&tmp->id,      sizeof(int));
	  Writen(om_fd, (void*)tmp->div_info, sizeof(DivInfo));
	} else {
	  int protocol = pReqValue;
	  Writen(om_fd, (void*)&protocol,     sizeof(int));
	  Writen(om_fd, (void*)&tmp->id,      sizeof(int));
	  Writen(om_fd, (void*)tmp->div_info, sizeof(DivInfo));
	}
      }
    }
  SKIP: ;
  }

  // ǡɬפʾϷ׻Ԥ
  if(module_tab.cal_num){
    Pthread_mutex_lock(&exec_info.lock);
  }

  // ׻åɤΩ夲 ---------------------------------
  pthread_t	   tid;
  pthread_attr_t attr;
  pthread_attr_init(&attr);
  pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
  
  Pthread_create(&tid, &attr, (void*(*)(void*))&execModule, NULL);
}



void
Ip::CheckNext()
{
    Pthread_mutex_unlock(&exec_info.lock);

    for(int i=0; i<module_tab.argc; i++) {
	vs_data* tmp = module_tab.argv[i];
	if(tmp->dtype != dALL) {
	    if(tmp->type & isIMG) {		// 2ǡФ
		int protocol = pReqImg;
		Writen(om_fd, (void*)&protocol,        sizeof(int));
		Writen(om_fd, (void*)&tmp->id,         sizeof(int));
		Writen(om_fd, (void*)&tmp->div_info[0],sizeof(DivInfo));
		Writen(om_fd, (void*)&tmp->div_info[module_tab.div_cnt+1],\
		                                       sizeof(DivInfo));
		module_tab.cal_num++;
	    }
	    else if(tmp->type & isCUB) {	// 3ǡФ
		int protocol = pReqCub;
		Writen(om_fd, (void*)&protocol,        sizeof(int));
		Writen(om_fd, (void*)&tmp->id,         sizeof(int));
		Writen(om_fd, (void*)&tmp->div_info[0],sizeof(DivInfo));
		Writen(om_fd, (void*)&tmp->div_info[1],sizeof(DivInfo));
		Writen(om_fd, (void*)&tmp->div_info[module_tab.div_cnt+2],\
		                                        sizeof(DivInfo));
		module_tab.cal_num++;
	    }

	    // ߤνꡤ1ǡκʬˤбƤʤ
	}
    }
    Pthread_mutex_lock(&exec_info.lock);
}

/* ----------------------------------------------------------------- *
 *            vios_runΥǡ˸ƤФؿ               *
 * ----------------------------------------------------------------- */
void
Ip::RecvImg()
{
    int	recv_id;
    Readn(om_fd, (void*)&recv_id, sizeof(int));

    // ǡμ
    vs_data* node = ip_table.get(recv_id);

    int ptr  = node->local->width * node->local->heigh;
    int size = node->local->width * node->div_info[module_tab.div_cnt+1].width;

    if(node->type == iIMG) {
	Readn(om_fd, (void*)((int*)node->val + ptr), size * sizeof(int));
    } else {
	Readn(om_fd, (void*)((FLOAT*)node->val + ptr), size * sizeof(FLOAT));
    }

    // 
    node->local->heigh += node->div_info[module_tab.div_cnt+1].width;
    fprintf(stderr,"h=%d\n",node->div_info[module_tab.div_cnt+1].width);
    // åξѲ뤫
    SetDike(module_tab.dike, node);

    // ⥸塼η³ݳǧ
    if(++module_tab.arg_cnt == module_tab.cal_num) {

	module_tab.arg_cnt = 0;
	module_tab.cal_num = 0;

	// ʬǡ׵
	if(++module_tab.div_cnt != exec_info.div_num) {
	    CheckNext();
	} else {
	    module_tab.div_cnt = 0;
	}

	Pthread_cond_broadcast(&exec_info.cond);
	Pthread_cond_signal(&exec_info.cyccond);
	Pthread_mutex_unlock(&exec_info.lock);
    }
}

void
Ip::RecvImgCyc(){ //åѤμؿɲ
  int recv_id,size,IS,num;
  DimInfo* dim;
  dim = new DimInfo;
  //fprintf(stderr,"In RecvImgCyc\n");
  //fprintf(stderr,"recv_id is = %d\n",recv_id);
  // ǡμ
  Readn(om_fd, (void*)&recv_id, sizeof(int));
  vs_data* node = ip_table.get(recv_id);
  // ޤ礭
  Readn(om_fd, (void*)&size, sizeof(int));
  Readn(om_fd, (void*)&IS, sizeof(int));
  Readn(om_fd, (void*)dim, sizeof(DimInfo));
  node->local->width = dim->width;
  node->c = dim->cache;
  node->IS = IS;
  node->dsize = size;
  //  indexμ
  Readn(om_fd, (void*)&num, sizeof(int));
  node->index = new int[num];
  Readn(om_fd, (void*)node->index, sizeof(int)*num);
  /*fprintf(stderr,"num=%d ",num);
  for(int i=0;i<num;i++){
    fprintf(stderr,"[%d]=%d ",i,node->index[i]);
  }
  fprintf(stderr,"\n");*/
  // tableμ
  node->gxtable = new int[node->orig->width];
  Readn(om_fd, (void*)node->gxtable, sizeof(int)*node->orig->width);
  /*for(int i=0;i<node->orig->width;i++){
    fprintf(stderr,"[%d]=%d ",i,node->gxtable[i]);
    }*/
  // ǡΤμ
  int ptr=0;
  if(node->type == iIMG){
    // åʤΤǥåparallelʸ򾯤Ԥ
    Pthread_mutex_lock(&exec_info.cyclock);
    node->val = new int[size];
    Pthread_cond_signal(&exec_info.cyccond);
    Pthread_mutex_unlock(&exec_info.cyclock);
    for(int i=0;i<dim->heigh;i+=512/exec_info.div_num){
      Readn(om_fd, (void*)((int*)node->val + ptr), sizeof(int)*dim->width*(512/exec_info.div_num));
      /*int* point = (int *)node->val;
      for(int i=0;i<4;i++){
	fprintf(stderr,"%d ",point[i]);
	}*/
      Pthread_mutex_unlock(&exec_info.lock);
      node->local->heigh += 1;
      //fprintf(stderr,"h=%d\n",node->local->heigh);
      Pthread_cond_signal(&exec_info.cyccond);
      ptr += dim->width;
      Pthread_mutex_lock(&exec_info.lock);
    }
    /*int* point = (int*)node->val;
    for(int i=0;i<size;i++){
      fprintf(stderr,"%d ",point[i]);
    }
    fprintf(stderr,"\n");*/
  } else {
  }
  // ⥸塼η³ݳǧ
  node->local->heigh = dim->heigh;
  //fprintf(stderr,"h=%d\n",node->local->heigh);
  //Pthread_cond_signal(&exec_info.cyccond);
  if(++module_tab.arg_cnt == module_tab.cal_num) {
    
    module_tab.arg_cnt = 0;
    module_tab.cal_num = 0;
    Pthread_cond_broadcast(&exec_info.cond);
    Pthread_cond_signal(&exec_info.cyccond);//¾ΤĤˤɲä
    Pthread_mutex_unlock(&exec_info.cyclock);//¾ΤĤˤɲä
    Pthread_mutex_unlock(&exec_info.lock);
  }
}

void
Ip::RecvCub()
{
    int	recv_id;
    Readn(om_fd, (void*)&recv_id, sizeof(int));

    // ǡμ
    vs_data* node = ip_table.get(recv_id);

    int ptr  = node->local->width * node->local->heigh * node->local->depth;
    int size = node->local->width * node->local->heigh \
	              * node->div_info[module_tab.div_cnt+2].width;

    if(node->type == iCUB)
	Readn(om_fd, (void*)((int*)node->val + ptr), size * sizeof(int));
    else
	Readn(om_fd, (void*)((FLOAT*)node->val + ptr), size * sizeof(FLOAT));

    // 
    node->local->depth += node->div_info[module_tab.div_cnt+2].width;

    // åξѲ뤫
    SetDike(module_tab.dike, node);

    // ⥸塼η³ݳǧ
    if(++module_tab.arg_cnt == module_tab.cal_num) {

	module_tab.arg_cnt = 0;
	module_tab.cal_num = 0;

	// ʬǡ׵
	if(++module_tab.div_cnt != exec_info.div_num) {
	    CheckNext();
	} else {
	    module_tab.div_cnt = 0;
	}
	Pthread_cond_broadcast(&exec_info.cond);
	Pthread_cond_signal(&exec_info.cyccond);
	Pthread_mutex_unlock(&exec_info.lock);
    }
}

void
Ip::RecvCubCyc(){ //åѤμؿɲ
}

void
Ip::RecvValue()
{
  int	recv_id;
  Readn(om_fd, (void*)&recv_id, sizeof(int));
  
  // ǡμ
  vs_data* node = ip_table.get(recv_id);
  
  int size = node->dsize * \
    ((node->type == INT)? sizeof(int) : sizeof(FLOAT));

  // tableμ
  node->gxtable = new int[node->orig->width];
  Readn(om_fd, (void*)node->gxtable, sizeof(int)*node->orig->width);
 
  // 
  // ߤνꡤʬˤбƤʤ
  node->local->width +=  node->div_info[0].width;
  
  Readn(om_fd, node->val, size);
  
  // ⥸塼η³ݳǧ
  if(++module_tab.arg_cnt == module_tab.cal_num) {
      
    module_tab.arg_cnt = 0;
    module_tab.cal_num = 0;
    
    // ʬʬΥǡ׵
    if(++module_tab.div_cnt != exec_info.div_num) {
      CheckNext();
    } else {
      module_tab.div_cnt = 0;
    }
    
    Pthread_cond_broadcast(&exec_info.cond);
    Pthread_cond_signal(&exec_info.cyccond);
    Pthread_mutex_unlock(&exec_info.lock);
  }
}

void
Ip::RecvValueCyc(){ //åѤμؿɲ
  int recv_id;
  int size,IS,cache;
  //fprintf(stderr,"In RecvValueCyc\n");
  Readn(om_fd, (void*)&recv_id, sizeof(int));
  //fprintf(stderr,"recv_id = %d\n",recv_id);
  // ǡμ
  vs_data* node = ip_table.get(recv_id);
  // ޤ礭
  Readn(om_fd, (void*)&size, sizeof(int));
  Readn(om_fd, (void*)&IS, sizeof(int));
  Readn(om_fd, (void*)&cache, sizeof(int));
  //fprintf(stderr,"size=%d,IS=%d,cache=%d\n",size,IS,cache);
  node->local->width = size;
  node->IS = IS;
  node->c = cache;
  node->dsize = size;
  //ǡΤμ
  if(node->type == INT){
    // åΰ褬ƤʤΤǡ
    node->val = new int[size];
    Readn(om_fd, node->val, sizeof(int)*size);
    /*int* point = (int*)node->val;
      for(int i=0;i<size;i++){
      fprintf(stderr,"%d ",point[i]);
      }*/
  } else {
    node->val = new FLOAT[size];
    Readn(om_fd, node->val, sizeof(FLOAT)*size);
  }
  // ⥸塼η³ݳǧ
  if(++module_tab.arg_cnt == module_tab.cal_num) {
    
    module_tab.arg_cnt = 0;
    module_tab.cal_num = 0;
    
    // ʬʬΥǡ׵
    if(++module_tab.div_cnt != exec_info.div_num) {
      CheckNext();
    } else {
      module_tab.div_cnt = 0;
    }
    Pthread_cond_broadcast(&exec_info.cond);
    Pthread_cond_signal(&exec_info.cyccond);
    Pthread_mutex_unlock(&exec_info.lock);
  }
}




/* ----------------------------------------------------------- *
 *                  vios_runȤγƼ                   *
 * ----------------------------------------------------------- */
void
Ip::ReqEnd()
{
    // 
    int comm = pEnd;
    Writen(om_fd, (void*)&comm, sizeof(int));
    if(conn_num) {
	Pthread_kill(conn_id1, SIGKILL);
	Pthread_kill(conn_id2, SIGKILL);
	for(int i=id+1; i<exec_info.host_num; i++) {
	    Close(readfd[i]);
	    Close(wrtefd[i]);
	}
    }
    sleep(1);
    exit(0);
}

// ȤꤢΥƥȡѹ
void
Ip::ReqSync()
{
    Pthread_mutex_lock(&slock);
    Pthread_cond_broadcast(&scond);
    Pthread_mutex_unlock(&slock);
}

void
Ip::ReqInfo()
{
    Readn(om_fd, (void*)&exec_info, sizeof(ExecInfo));
    Readn(om_fd, (void*)&id, sizeof(int));	// ipid

    Pthread_mutex_init(&exec_info.lock, NULL);
    pthread_cond_init(&exec_info.cond, NULL);

    Pthread_mutex_init(&slock, NULL);
    pthread_cond_init(&scond, NULL);
}


//   -------------------------------------------
void
Ip::ReqUnion()
{
    if(data->type & INT) {
	Readn(om_fd, data->val, data->size * sizeof(int));
    } else {
	Readn(om_fd, data->val, data->size * sizeof(FLOAT));
    }
    Pthread_cond_broadcast(&exec_info.cond);
}


// OMؤβᤷؿ  -----------------------------------------
void
Ip::ReqGather()
{
    int val_id;
    Readn(om_fd, (void*)&val_id, sizeof(int));
    vs_data* ptr = ip_table.get(val_id);

    Protocol(pGather);

    int*   iptr;
    FLOAT* fptr;

#define _VS_GATHER_1D(_VS_TYPE, _VS_TYPE_VAL)				  \
	Writen(om_fd, ptr->div_info,    sizeof(DivInfo));		  \
	Writen(om_fd, ptr->cache,       sizeof(int) * 2);		  \
									  \
        _VS_TYPE_VAL = (_VS_TYPE*)ptr->val + ptr->cache[2];		  \
        Writen(om_fd, _VS_TYPE_VAL, ptr->work->width * sizeof(_VS_TYPE))


#define _VS_GATHER_2D(_VS_TYPE, _VS_TYPE_VAL)				      \
	Writen(om_fd, ptr->div_info,    sizeof(DivInfo)*2);		      \
	Writen(om_fd, ptr->cache,       sizeof(int)    *4);		      \
	Writen(om_fd,&ptr->work->heigh, sizeof(int));			      \
									      \
	_VS_TYPE_VAL = (_VS_TYPE*)ptr->val +				      \
	    (ptr->local->width * ptr->cache[0]) + ptr->cache[2];	      \
									      \
	for(int i= 0; i< ptr->work->heigh ; i++) {			      \
	    Writen(om_fd, _VS_TYPE_VAL, ptr->work->width * sizeof(_VS_TYPE)); \
	    _VS_TYPE_VAL += ptr->local->width;				      \
	}


    //  (Imageʳˤб褦)
    switch(ptr->type) {
      case INT:
	_VS_GATHER_1D(int,   iptr);
	break;
      case FLT:
	_VS_GATHER_1D(FLOAT, fptr);
	break;
      case iIMG:
	_VS_GATHER_2D(int,   iptr);
	break;
      case fIMG:
	_VS_GATHER_2D(FLOAT, fptr);
	break;
    }

#undef _VS_GATHER_1D
#undef _VS_GAGHER_2D
}







/* ------------------------------------------------------- */
/* ------------------------------------------------------- */
// ¾δؿǰư or ѹ

void
Ip::SetDike(int dike, vs_data* ptr)
{
    bzero(ptr->cache, sizeof(int) * 6);

    switch(ptr->type) {
      case iCUB:
      case fCUB:
	//  ------------------
	ptr->cache[4] = ((ptr->div_info[2].index)? ptr->orig->cache : dike);

	// ʺʬαƶͭ
	if(exec_info.div_num == 1) {
	    ptr->cache[5] = \
		(((ptr->div_info[2].index + ptr->div_info[2].width) \
			      != ptr->orig->depth)? ptr->orig->cache : dike);
	} else {
	    ptr->cache[5] = ptr->orig->cache;
	}
	ptr->work->depth = ptr->local->depth - ptr->cache[4] - ptr->cache[5];

      case iIMG:
      case fIMG:
	//  ----------------------
	ptr->cache[0] = ((ptr->div_info[1].index)? ptr->orig->cache : dike);

	// ʺʬαƶͭ---
	if((exec_info.div_num == 1) || (ptr->type & isCUB)) {
	    ptr->cache[1] = \
		(((ptr->div_info[1].index + ptr->div_info[1].width) \
		  != ptr->orig->heigh)? ptr->orig->cache : dike);
	} else {
	    ptr->cache[1] = ptr->orig->cache;
	}
	ptr->work->heigh = ptr->local->heigh - ptr->cache[0] - ptr->cache[1];
	
      default:
	//  ----------------------
	ptr->cache[2] = ((ptr->div_info[0].index)?  ptr->orig->cache : dike);

	//  ----------------------
	ptr->cache[3] =(((ptr->div_info[0].index + ptr->div_info[0].width) \
			 != ptr->orig->width)? ptr->orig->cache : dike);

	ptr->work->width = ptr->local->width - ptr->cache[2] - ptr->cache[3];
    }
    module_tab.dike = dike;
}
