/*********************************************************************
  divcyclib.h
  $B%5%$%/%j%C%/J,3dMQ$N%i%$%V%i%j(B
*********************************************************************/
#include "om_struct.h"
#include "vios_run.h"
#include "om_table.h"

vs_data* Cyclic_divide(vs_data* data, int id, int host_num){ //1$B<!85MQ(B
  int width = data->dim->width;    // $B2#I}(B
  int c = data->dim->cache;        // $B%-%c%C%7%e%5%$%:(B
  int x = data->div_hint.x_divide;// $B%5%$%/%j%C%/$N2#$NI}(B
  int n = width/(x * host_num);    // x$BJ}8~$G2?%V%m%C%/C4Ev$9$k$+(B
  int point = id * x;             // $B@hF,(B
  int k,num;
  int sflag = 1;
  int IS=0;
  int top;
  vs_data* new_data;
  k=0;
  num=0;
  new_data = new vs_data;

  if((width % (x * host_num)) != 0){ // $B3d$j$-$l$J$$$J$iJ,3dITG=(B
    fprintf(stderr,"data can't divide in cyclic\n");
    exit(0);
  }

  top = point;
  for(int i=0;i<n;i++){
    for(int j=point-c;j<point+x+c;j++){
      if( (j>=0) && (j<width)){
	num++; // 1$B9T$"$?$j$N?t(B
      }
    }
    point += x * host_num;
  }
  if(data->type == INT){
    int* ival;
    int* itemp = (int *)data->val;
    ival = new int[num];
    point = top;
    for(int i=0;i<n;i++){
      for(int j=point-c;j<point+x+c;j++){
	if( (j>=0) && (j<width)){
	  ival[k++] = itemp[j];
	  if(sflag && (j==point)){
	    sflag = 0;
	    IS = k-1;
	  }
	  //fprintf(stderr,"%d ",ival[k-1]);
	}
      }
      point += x * host_num;
    }
    new_data->val = (void *)ival;
    new_data->size = k;
    new_data->num = num;
    new_data->IS = IS;
    //fprintf(stderr,"finish\n");
    return(new_data);
  } else {
    FLOAT* fval = (FLOAT *)malloc(sizeof(FLOAT) * num);
    FLOAT* ftemp = (FLOAT *)data->val;
    for(int i=0;i<n;i++){
      for(int j=point-c;j<point+x+c;j++){
	if( (j>=0) && (j<width)){
	  fval[k++] = ftemp[j];
	  if(sflag && (j==point)){
	    sflag = 0;
	    IS = k-1;
	  }
	}
      }
      point += x * host_num;
    }
    new_data->val = (void*)fval;
    new_data->size = k;
    new_data->num = num;
    new_data->size = IS;
    return(new_data);
  }
}


vs_data* Cyclic_divide2D(vs_data* data, int id, int host_num){ //2$B<!85MQ(B
  int width = data->dim->width;    // $B2#I}(B
  int heigh = data->dim->heigh;    // $B=D(B
  int c = data->dim->cache;        // $B%-%c%C%7%e%5%$%:(B
  int x = data->div_hint.x_divide; // $B%5%$%/%j%C%/$N2#$NI}(B
  int y = data->div_hint.y_divide; // $B%5%$%/%j%C%/$N=D$NI}(B
  int k,num,n,point,top;
  int sflag = 1;
  int IS=0;
  vs_data* new_data;
  k=0;
  num=0;
  new_data = new vs_data;
  
  if(x != 0){ // x$B$,(B0$B$G$J$$$J$i(BCOL
    if((width%(x * host_num)) != 0){
      fprintf(stderr,"data can't divide in cyclic\n");
      exit(0);
    }
    n = width/(x * host_num);  // x$BJ}8~$G2?%V%m%C%/C4Ev$9$k$+(B
    point = id * x; //$B@hF,(B
    top = point;

    for(int i=0;i<n;i++){
      for(int j=point-c;j<point+x+c;j++){
	if( (j>=0) && (j<width)){
	  num++; // 1$B9T$"$?$j$N?t(B
	}
      }
      point += x * host_num;
    }
    //fprintf(stderr,"w=%d,h=%d,x=%d,y=%d,c=%d,n=%d,num=%d\n",width,heigh,x,y,c,n,num);
    if(data->type == iIMG){
      int* ival;
      int* itemp = (int *)data->val;
      ival = new int[num*heigh];
      for(int y=0;y<heigh;y++){
	point = top + y * width;
	for(int i=0;i<n;i++){
	  for(int j=point-c;j<point+x+c;j++){
	    if(((j-y*width)>=0)&&((j-y*width)<width)){
	      ival[k++] = itemp[j];
	      if(sflag && (j==point)){
		sflag = 0;
		IS = k-1;
	      }
	      //fprintf(stderr,"%d ",ival[k-1]);
	    }
	  }
	  point += x * host_num;
	}
      }
      new_data->val = (void*)ival;
      new_data->size = k;
      new_data->num = n;
      new_data->IS = IS;
      new_data->dim = new DimInfo;
      new_data->dim->heigh = heigh;
      new_data->dim->width = k / heigh;
      new_data->dim->cache = c;
      // $BI}!"9b$5$rBeF~$7$FJV$9!)(B
      return(new_data);
    } else {
      // FLOAT$B$O8e2s$7(B
    }
  } else {    // x$B$,(B0(y$B$,(B0$B$G$J$$(B)$B$J$i(BROW
    if((heigh%(y * host_num)) != 0){
      fprintf(stderr,"data can't divide in cyclic\n");
      exit(0);
    }
    n = heigh/(y * host_num);  // y$BJ}8~$G2?%V%m%C%/C4Ev$9$k$+(B
    point = id * y * width;     //$B@hF,(B
    num = width; // 1$B9T$"$?$j$N?t(B

    if(data->type == iIMG){
      int* ival;
      int* itemp = (int *)data->val;
      ival = new int[num*heigh];

      // $B$^$@9M$(Cf(B

    } else {
    }
  }
}
