/*********************************************************************
  om_recv.cc
    IP => OM ̿
*********************************************************************/
#include <string.h>
#include "vios_run.h"
#include "om_table.h"
#include "divcyclib.h"
#include "maketable.h"

static fd_set	fds;
static int	waitfd;
static int	next;

vs_data* Cyclic_divide(vs_data* data, int id, int host_num);

void
Om::InitFD()
{
    FD_ZERO(&fds);
    waitfd = 0;
    for(int i=0; i<exec_info.host_num; i++) {
	FD_SET(ip_fd[i], &fds);
	if(ip_fd[i] > waitfd) waitfd = ip_fd[i];
    }
    waitfd++;
}

void
Om::FromIP()
{
  next = 1;
  while(next > 0) {
    Select(waitfd, &fds, NULL, NULL, NULL);
    
    for(int i=0; i<exec_info.host_num; i++) {
      int recv_id;
      if(FD_ISSET(ip_fd[i], &fds)) {
	id = i;
	Readn(ip_fd[i], (void*)&recv_id, sizeof(int));
	//fprintf(stderr,"come request:%d from %d.\n", recv_id,i);
		
	//timeval st, et;
	//Gettimeofday(&st, NULL);

	(this->*Om::Recv[recv_id])();
	//fprintf(stderr,"finish request:%d from %d.\n",recv_id,i);
	//Gettimeofday(&et, NULL);
	//double t = et.tv_sec - st.tv_sec + \
		//  (et.tv_usec - st.tv_usec) * 0.000001;
	//fprintf(stderr,"   communication time: %1.4lf\n", t);

      }
      FD_SET(ip_fd[i], &fds);
      recv_id = -1;
    }
  }
  if(next == -1) {
    for(int i=0; i< exec_info.host_num; i++) 
      Close(ip_fd[i]);
  }
}

void
Om::RecvDone()
{
    // Ʊ¹Ԥ⥸塼θ뤳
    if(++ip_cnt == exec_info.host_num) {
	ip_cnt = 0; next    =  0;
    }
}

void
Om::RecvEnd()
{
    if(++ip_cnt == exec_info.host_num) {
	ip_cnt = 0; next = -1;
    }
}

// Ūʤ
void
Om::RecvSync()
{
    if(++ip_cnt == exec_info.host_num) {
	for(int i=0; i<exec_info.host_num; i++) {
	    id = i;
	    SendIP(pSync);
	}
	ip_cnt = 0;
    }
}


void
Om::RecvImg()
{
    // ǡꥯȤ  ----------------------------

    int		img_id;
    DivInfo 	div_info[MAX_DIM];
    Readn(ip_fd[id], (void*)&img_id,   sizeof(int));
    Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo) * 2);

    vs_data*	img = g_table.get(img_id);

    // ǡ  ------------------------------------
    SendIP(pReqImg);
    Writen(ip_fd[id], (void*)&img_id,  sizeof(int));

    if(img->type == iIMG) {
	int* iimg = (int*)img->val + div_info[1].index * img->dim->width;

	for(int i=0; i<div_info[1].width; i++) {
	    Writen(ip_fd[id], (void*)(iimg + div_info[0].index), \
				      sizeof(int)   * div_info[0].width);
	    iimg += img->dim->width;
	}
    } else {
	FLOAT* fimg = (FLOAT*)img->val + div_info[1].index * img->dim->width;

	for(int i=0; i<div_info[1].width; i++) {
	    Writen(ip_fd[id], (void*)(fimg + div_info[0].index), \
				      sizeof(FLOAT) * div_info[0].width);
	    fimg += img->dim->width;
	}
    }
}

void
Om::RecvImgCyc(){ //åѤμؿɲ
  // ǡꥯȤ  ----------------------------
  int	  img_id;
  DivInfo div_info;
  vs_data* new_data;
  //fprintf(stderr,"In RecvImgCyc\n");
  Readn(ip_fd[id], (void*)&img_id,   sizeof(int));
  // ϣĤǤΤ
  //Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo));
  //fprintf(stderr,"index=%d,width=%d\n",div_info.index,div_info.width);
  vs_data* img = g_table.get(img_id);
  // ǡ  ------------------------------------
  SendIP(pReqImgCyc);
  Writen(ip_fd[id], (void*)&img_id,  sizeof(int));
  // åʬ䤷ǡ
  new_data = Cyclic_divide2D(img,id,exec_info.host_num);
  int size = new_data->size;
  int IS = new_data->IS;
  int num = new_data->num;
  int x = img->div_hint.x_divide;
  fprintf(stderr,"num=%d,x=%d\n",num,x);
  DimInfo* dim = new_data->dim;
  //dim = new_data->dim;
  // parallel˻Ȥindexκ(ϴؿ٤)
  int inum = new_data->num * img->div_hint.x_divide;
  int * index = new int[inum];
  int point = IS;
  int ptemp;
  int i = 0;
  while(i<inum){
    ptemp = point;
    for(int j=0;j<x;j++){
      index[i++] = ptemp++;
    }
    point += 2*dim->cache + x;
  }
  // g2lѤΥơ֥ޤx
  int * g_table_x = gxtable_cyc(img,id,IS);
  /*for(int i=0;i<img->dim->width;i++){
    fprintf(stderr,"[%d]=%d ",i,g_table_x[i]);
    }*/
  // ޤ礭
  Writen(ip_fd[id], (void*)&size, sizeof(int));
  Writen(ip_fd[id], (void*)&IS, sizeof(int));
  Writen(ip_fd[id], (void*)dim, sizeof(DimInfo));
  // index
  Writen(ip_fd[id], (void*)&inum, sizeof(int));
  fprintf(stderr,"inum=%d\n",inum);
  Writen(ip_fd[id], (void*)index, sizeof(int)*inum);
  // table
  Writen(ip_fd[id], (void*)g_table_x, sizeof(int)*img->dim->width);
  // ǡΤ
  if(img->type == iIMG) {
    Writen(ip_fd[id], (void*)((int*)new_data->val),sizeof(int)*size);
  } else {
  }
}

void
Om::RecvCub()
{
    // ǡꥯȤ  ----------------------------
    int		cub_id;
    DivInfo 	div_info[MAX_DIM];
    Readn(ip_fd[id], (void*)&cub_id,   sizeof(int));
    Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo) * MAX_DIM);

    vs_data* cub = g_table.get(cub_id);


    // ǡ  ------------------------------------

    SendIP(pReqCub);
    Writen(ip_fd[id], (void*)&cub_id,  sizeof(int));

    if(cub->type == iCUB) {
	int* icub = (int*)cub->val \
	           + div_info[2].index * cub->dim->width * cub->dim->heigh \
		   + div_info[1].index * cub->dim->width \
		   + div_info[0].index;

	for(int i=0; i<div_info[2].width; i++) {
	    for(int j=0; j<div_info[1].width; j++) {
		Writen(ip_fd[id], icub, sizeof(int) * div_info[0].width);
		icub += cub->dim->width;
	    }
	    icub += cub->dim->width * (cub->dim->heigh - div_info[1].width);
	}
    } else {
	FLOAT* fcub = (FLOAT*)cub->val \
	             + div_info[2].index * cub->dim->width * cub->dim->heigh \
		     + div_info[1].index * cub->dim->width \
		     + div_info[0].index;

	for(int i=0; i<div_info[2].width; i++) {
	    for(int j=0; j<div_info[1].width; j++) {
		Writen(ip_fd[id], fcub, sizeof(FLOAT) * div_info[0].width);
		fcub += cub->dim->width;
	    }
	    fcub += cub->dim->width * (cub->dim->heigh - div_info[1].width);
	}
    }
}

void
Om::RecvCubCyc(){ //åѤμؿɲ
}

void
Om::RecvValue()
{
  // ǡꥯȤ  ----------------------------
  int		val_id;
  DivInfo 	div_info;
  Readn(ip_fd[id], (void*)&val_id,   sizeof(int));
  Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo));
  
  vs_data*	val = g_table.get(val_id);


  // ǡ  ------------------------------------
  SendIP(pReqValue);
  Writen(ip_fd[id], (void*)&val_id,  sizeof(int));
  
  // table¾Τˤɲä뤳
  int * g_table_x = new int[val->dim->width];
  g_table_x = gxtable(val, id);
  Writen(ip_fd[id], (void*)g_table_x, sizeof(int)*val->dim->width);

  if(val->type == INT) {
    Writen(ip_fd[id], (void*)(  (int*)val->val + div_info.index), \
	   sizeof(int) * div_info.width);
  } else {
    Writen(ip_fd[id], (void*)((FLOAT*)val->val + div_info.index), \
	   sizeof(FLOAT) * div_info.width);
  }
}

void
Om::RecvValueCyc(){ //åѤμؿɲ
  int val_id=0;
  vs_data* new_data;
  DivInfo div_info;
  //fprintf(stderr,"In RecvValueCyc\n");
  Readn(ip_fd[id], (void*)&val_id, sizeof(int));
  Readn(ip_fd[id], (void*)&div_info, sizeof(DivInfo));

  vs_data* val = g_table.get(val_id);
  // ǡ  ------------------------------------
  SendIP(pReqValueCyc); //åʤΤ
  Writen(ip_fd[id], (void*)&val_id, sizeof(int));

  // åʬ䤷ǡ
  new_data = Cyclic_divide(val,id,exec_info.host_num);
  int size = new_data->size;
  int IS = new_data->IS;
  int cache = val->dim->cache;
  //fprintf(stderr,"size=%d,IS=%d,cache=%d\n",size,IS,cache);
  // ޤ礭
  Writen(ip_fd[id], (void*)&size, sizeof(int));
  Writen(ip_fd[id], (void*)&IS, sizeof(int));
  Writen(ip_fd[id], (void*)&cache, sizeof(int));
  // ǡΤ
  if(val->type == INT) {
    Writen(ip_fd[id],(void*)((int*)new_data->val),sizeof(int)*size);
  } else {
    Writen(ip_fd[id],(void*)((FLOAT*)new_data->val),
	   sizeof(FLOAT)*size);
  }
}


// ΰؤΥʤΤ¾ɬ̵Ϥ -------------
void
Om::RecvGather()
{
    vs_data* ptr = module_tab.ptr;

    DivInfo  div_info[3];
    int	     cache[6];
    int	     line;

    int*     iptr;
    FLOAT*   fptr;

#define _VS_GATHER_1D(_VS_TYPE, _VS_TYPE_VAL)				     \
	Readn(ip_fd[id], (void*)div_info, sizeof(DivInfo));		     \
        Readn(ip_fd[id], (void*)cache,    sizeof(int) * 2);		     \
	_VS_TYPE_VAL = (_VS_TYPE*)ptr->val + div_info[0].index + cache[2];   \
	Readn(ip_fd[id], _VS_TYPE_VAL,					     \
	      (div_info[0].width - cache[2] - cache[3]) * sizeof(_VS_TYPE))


#define _VS_GATHER_2D(_VS_TYPE, _VS_TYPE_VAL)				     \
	Readn(ip_fd[id], (void*)div_info, sizeof(DivInfo) * 2);		     \
        Readn(ip_fd[id], (void*)cache,    sizeof(int)     * 4);		     \
	Readn(ip_fd[id], (void*)&line,    sizeof(int));			     \
	_VS_TYPE_VAL = (_VS_TYPE*)ptr->val + (div_info[1].index + cache[0])  \
	                 * ptr->dim->width + (div_info[0].index + cache[2]); \
									     \
	for(int i= 0; i< line; i++) {					     \
	    Readn(ip_fd[id], _VS_TYPE_VAL,				     \
	      (div_info[0].width - cache[2] - cache[3]) * sizeof(_VS_TYPE)); \
	    _VS_TYPE_VAL += ptr->dim->width;				     \
	}

    switch(ptr->type) {
      case INT:
	_VS_GATHER_1D(int,   iptr);
	break;
      case FLT:
	_VS_GATHER_1D(FLOAT, fptr);
	break;
      case iIMG:
	_VS_GATHER_2D(int,   iptr);
	break;
      case fIMG:
	_VS_GATHER_2D(FLOAT, fptr);
	break;
    }

#undef _VS_GATHER_1D
#undef _VS_GAGHER_2D

    if(++ip_cnt == exec_info.host_num) {
	ip_cnt = 0; next = 0;
    }
}

void
Om::RecvUnion()
{
  UnionInfo uni;
  Readn(ip_fd[id], &uni.id, sizeof(UnionInfo) - sizeof(int));
    
  vs_data* ptr = module_tab.argv[uni.id];
    
  if(ptr->type != vsAGGRIGATE) {
    void* temp;
    if(!(ptr->uniflg)){ //ǽΤʤ̵˺
      // ե  -------------------------------------
      if(ptr->type & INT){
	temp = new int[ptr->size];
	Readn(ip_fd[id], temp, ptr->size * sizeof(int));
	memcpy(ptr->val, temp, sizeof(int) * ptr->size);
	ptr->uniflg = 1; // ե饰ΩƤ
      } else {
	temp = new FLOAT[ptr->size];
	Readn(ip_fd[id], temp, ptr->size * sizeof(FLOAT));
	memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
	ptr->uniflg = 1; // ե饰ΩƤ
      }
      // ǽμʤΤUnion̵
    } else {  //ǽΤǤϤʤʤ餽줾̿˱ƽ
      // ե  -------------------------------------
      if(ptr->type & INT) {
	temp = new int[ptr->size];
	Readn(ip_fd[id], temp, ptr->size * sizeof(int));
      } else {
	temp = new FLOAT[ptr->size];
	Readn(ip_fd[id], temp, ptr->size * sizeof(FLOAT));
      }
      
      // Unionե  ------------------------------------
      if(ptr->type & INT) {
	switch(uni.type) {
	case vsUNI:
	  memcpy(ptr->val, temp, sizeof(int) * ptr->size);
	  break;
	case vsADD:
	  for(int i=0; i< ptr->size; i++)
	    ((int*)ptr->val)[i] += ((int*)temp)[i];
	  break;
	case vsMAX:
	  for(int i=0; i< ptr->size; i++)
	    if(((int*)ptr->val)[i] < ((int*)temp)[i])
	      ((int*)ptr->val)[i] = ((int*)temp)[i];
	  break;
	case vsMIN:
	  for(int i=0; i< ptr->size; i++)
	    if(((int*)ptr->val)[i] > ((int*)temp)[i])
	      ((int*)ptr->val)[i] = ((int*)temp)[i];
	  break;
	case vsMAX_DEPEND_ON_FIRST:
	  if(((int*)ptr->val)[0] < ((int*)temp)[0])
	    memcpy(ptr->val, temp, sizeof(int) * ptr->size);
	  break;
	case vsMIN_DEPEND_ON_FIRST:
	  if(((int*)ptr->val)[0] > ((int*)temp)[0])
	    memcpy(ptr->val, temp, sizeof(int) * ptr->size);
	  break;
	}
	delete[] (int*)temp;
      } else {
	switch(uni.type) {
	case vsUNI:
	  memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
	  break;
	case vsADD:
	  for(int i=0; i< ptr->size; i++)
	    ((FLOAT*)ptr->val)[i] += ((FLOAT*)temp)[i];
	  break;
	case vsMAX:
	  for(int i=0; i< ptr->size; i++)
	    if(((FLOAT*)ptr->val)[i] < ((FLOAT*)temp)[i])
	      ((FLOAT*)ptr->val)[i] = ((FLOAT*)temp)[i];
	  break;
	case vsMIN:
	  for(int i=0; i< ptr->size; i++)
	    if(((FLOAT*)ptr->val)[i] > ((FLOAT*)temp)[i])
	      ((FLOAT*)ptr->val)[i] = ((FLOAT*)temp)[i];
	  break;
	case vsMAX_DEPEND_ON_FIRST:
	  if(((FLOAT*)ptr->val)[0] < ((FLOAT*)temp)[0])
	    memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
	  break;
	case vsMIN_DEPEND_ON_FIRST:
	  if(((FLOAT*)ptr->val)[0] > ((FLOAT*)temp)[0])
	  memcpy(ptr->val, temp, sizeof(FLOAT) * ptr->size);
	  break;
	}
	delete[] (FLOAT*)temp;
      }
    }
    
    // ե  ---------------------------------------------
    if(++ip_cnt == exec_info.host_num) { //Τä
      
      if(ptr->type & INT) {
	for(int i=0; i<exec_info.host_num; i++) {
	  id = i;
	  SendIP(pUnion);
	  Writen(ip_fd[i], ptr->val, ptr->size * sizeof(int));
	}
      } else {
	for(int i=0; i<exec_info.host_num; i++) {
	  id = i;
	  SendIP(pUnion);
	  Writen(ip_fd[i], ptr->val, ptr->size * sizeof(FLOAT));
	}
      }
      ip_cnt = 0;
      ptr->uniflg = 0; // 꽪Τǽ
    }
  }
}

void
Om::RecvVote()
{
    UnionInfo vote;	// Ȥꤢ
    Readn(ip_fd[id], &vote.id, sizeof(UnionInfo) - sizeof(int));

    vs_data* ptr = module_tab.argv[vote.id];

    // ե  -----------------------------------------
    if(ptr->type == INT) {
	Readn(ip_fd[id],   (int*)ptr->val + vote.type, sizeof(int));
    } else {
	Readn(ip_fd[id], (FLOAT*)ptr->val + vote.type, sizeof(FLOAT));
    }
}



