/********************************************************************
  om_table.cc
    Τɬפʾ(ѿ¹Ի)δԤ
*********************************************************************/
#include <string.h>
#include "om_table.h"


OmTable::OmTable()
{
    begin.id	= -1;
    begin.size	=  1;
    begin.next 	= (vs_data*)NULL;
    count 	=  0;
}

vs_data*
OmTable::regist(int type, const char* name, int num)
{
    vs_data *new_val = new vs_data;	// ѿ˴ؤ

    new_val->id		= count++;
    new_val->type	= type;
    new_val->size	= num;
    new_val->uniflg     = 0; // unionѤΥե饰ɲ

    new_val->dim 	= new DimInfo;
    new_val->dim->width	= num;

    new_val->dtype	= dALL;

    // 0(NULL)֤Ǥ뤳ȤȤ
    bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
    bzero((void*)&new_val->div_info, sizeof(DivInfo*));

    int*   itmp;
    FLOAT* ftmp;
    char*  ctmp;
    switch(type) {			// ͤΰ
      case INT:
	new_val->val = new int[num];
	break;
      case FLT:
	new_val->val = new FLOAT[num];
	break;
      case STR:
	new_val->val = new char[num];
    }

    // ѿ̾
    size_t size   = strlen(name)+1;
    new_val->name = new char[size];
    memcpy(new_val->name, (void*)name, size);

    // Ͽ
    new_val->next	= begin.next;
    begin.next		= new_val;

    return new_val;
}

// ѿ
vs_data*
OmTable::regist(int type, const char* name, int width, int heigh)
{
    vs_data *new_val 	= new vs_data;	// ѿ˴ؤ
    new_val->id		= count++;
    new_val->type	= type;
    new_val->size	= width * heigh;
    new_val->uniflg     = 0; // unionѤΥե饰ɲ

    new_val->dim 	= new DimInfo;
    new_val->dim->width	= width;
    new_val->dim->heigh = heigh;

    bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
    bzero((void*)&new_val->div_info, sizeof(DivInfo*) * MAX_DIM);


    // ǥեȤʬʤɤ˴ؤ  --------------------------
    new_val->dim->cache = 0;
    new_val->dtype 	= dPIXEL;


    switch(type) {			// ͤΰ
      case iIMG :
	new_val->val = new int[new_val->size];
	bzero(new_val->val, new_val->size * sizeof(int));
	break;
      case fIMG :
	new_val->val = new FLOAT[new_val->size];
	bzero(new_val->val, new_val->size * sizeof(FLOAT));
    }
    
                                         // ѿ̾
    size_t size   	= strlen(name)+1;
    new_val->name 	= new char[size];
    memcpy(new_val->name, (void*)name, size);


    new_val->next	= begin.next;
    begin.next		= new_val;

    return new_val;
}

// Ūʥե뤫ɤ߹ߡɲ
vs_data*  //1
OmTable::regist1D(int type, char* name, int x_size, char* path, int mode){
  vs_data *new_val = new vs_data;	// ѿ˴ؤ
  
  new_val->id	= count++;
  new_val->type	= type;
  new_val->size	= x_size;
  new_val->uniflg     = 0; // unionѤΥե饰ɲ
  
  new_val->dim 	= new DimInfo;
  new_val->dim->width = x_size;

  if(mode == 1){ // ƥȥ⡼
    switch(type){			// ͤΰ
    case INT:
      new_val->val = iRead(path,new_val->size,(int*)new_val->val);
      break;
    case FLT:
      new_val->val = fRead(path,new_val->size,(FLOAT*)new_val->val);
      break;
    }
  } else {  // Хʥ⡼
    switch(type){
    case INT:
      new_val->val = iReadBin(path,new_val->size,(int*)new_val->val);
      break;
    case FLT:
      new_val->val = fReadBin(path,new_val->size,(FLOAT*)new_val->val);
      break;
    }
  }
  // ɤ߹ؿ ../lib/readlib.c

  // 0(NULL)֤Ǥ뤳ȤȤ
  bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
  bzero((void*)&new_val->div_info, sizeof(DivInfo*));

  size_t size  	= strlen(name)+1;	// ѿ̾
  new_val->name	= new char[size];

  memcpy(new_val->name, (void*)name, size);
  new_val->next	= begin.next;
  begin.next	= new_val;

  return new_val;
  
}

vs_data* //2
OmTable::regist2D(int type, char* name, int x_size, int y_size,
		  char* path, int mode){
  vs_data *new_val = new vs_data;	// ѿ˴ؤ
  new_val->id	   = count++;
  new_val->type	= type;
  new_val->size	= x_size * y_size;
  new_val->uniflg     = 0; // unionѤΥե饰ɲ

  if(mode == 1){  // ƥȥ⡼
    switch(type) {			// ͤΰ
    case iIMG:
      new_val->val = iRead(path,new_val->size,(int*)new_val->val);
      break;
    case fIMG:
      new_val->val = fRead(path,new_val->size,(FLOAT*)new_val->val);
      break;
    }
  } else {
    switch(type) {  // Хʥ⡼
    case iIMG:
      new_val->val = iReadBin(path,new_val->size,(int*)new_val->val);
      break;
    case fIMG:
      new_val->val = fReadBin(path,new_val->size,(FLOAT*)new_val->val);
      break;
    }
  }
  // ɤ߹ؿ ../lib/readlib.c

  new_val->dim 	= new DimInfo;
  new_val->dim->width = x_size;
  new_val->dim->heigh = y_size;

  bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
  bzero((void*)&new_val->div_info, sizeof(DivInfo*) * MAX_DIM);
  
  new_val->dim->cache = 0;
  new_val->dtype 	= dPIXEL;

  size_t size  	= strlen(name)+1;	// ѿ̾
  new_val->name	= new char[size];

  memcpy(new_val->name, (void*)name, size);
  new_val->next	= begin.next;
  begin.next	= new_val;

  return new_val;
}

vs_data* //3
OmTable::regist3D(int type, char* name, int x_size, int y_size,
		  int z_size, char* path, int mode){
  vs_data *new_val = new vs_data;	// ѿ˴ؤ
  new_val->id	   = count++;
  new_val->type	= type;
  new_val->size	= x_size * y_size * z_size;
  new_val->uniflg     = 0; // unionѤΥե饰ɲ

  if(mode == 1){  // ƥȥ⡼
    switch(type) {			// ͤΰ
    case iCUB:
      new_val->val = iRead(path,new_val->size,(int*)new_val->val);
      break;
    case fCUB:
      new_val->val = fRead(path,new_val->size,(FLOAT*)new_val->val);
      break;
    }
  } else { // Хʥ⡼
    switch(type) {
    case iCUB:
      new_val->val = iReadBin(path,new_val->size,(int*)new_val->val);
      break;
    case fCUB:
      new_val->val = fReadBin(path,new_val->size,(FLOAT*)new_val->val);
      break;
    }
  }
  // ɤ߹ؿ ../lib/readlib.c

  new_val->dim 	= new DimInfo;
  new_val->dim->width = x_size;
  new_val->dim->heigh = y_size;
  new_val->dim->depth = z_size;
  // 0(NULL)֤Ǥ뤳ȤȤ
  bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
  bzero((void*)&new_val->div_info, sizeof(DivInfo*) * MAX_DIM);
  // ǥեȤʬʤɤ˴ؤ  --------------------------
  new_val->dim->cache = 0;
  new_val->dtype      = dPIXEL;

  // ѿ̾
  size_t size   = strlen(name)+1;
  new_val->name = new char[size];
  memcpy(new_val->name, (void*)name, size);

  new_val->next	= begin.next;
  begin.next	= new_val;
  
  return new_val;

}


// ѿѡʥե뤫ɤ߹ߡ -------------------------
vs_data*
OmTable::regist(char* name, char* path)
{
    int width = 0, heigh = 0;
    vs_data *new_val 	= new vs_data;	// ѿ˴ؤ
    new_val->id		= count++;
    new_val->type	= iIMG;
    new_val->uniflg     = 0; // unionѤΥե饰ɲ

    // μͽ

    if(Pgm_load(path, &width, &heigh, (int**)&new_val->val) == -1)
	return NULL;

    new_val->size	= width * heigh;

    new_val->dim 	= new DimInfo;
    new_val->dim->width	= width;
    new_val->dim->heigh = heigh;

    bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
    bzero((void*)&new_val->div_info, sizeof(DivInfo*) * MAX_DIM);


    // ǥեȤʬʤɤ˴ؤ  --------------------------
    new_val->dim->cache = 0;
    new_val->dtype 	= dPIXEL;

    size_t size   	= strlen(name)+1;	// ѿ̾
    new_val->name 	= new char[size];
    
    memcpy(new_val->name, (void*)name, size);

    new_val->next	= begin.next;
    begin.next		= new_val;

    return new_val;
}



// 3-Dѿ
vs_data*
OmTable::regist(int type, const char* name, int width, int heigh, int depth)
{
    vs_data *new_val 	= new vs_data;	// ѿ˴ؤ
    new_val->id		= count++;
    new_val->type	= type;
    new_val->size	= width * heigh *  depth;
    new_val->uniflg     = 0; // unionѤΥե饰ɲ

    new_val->dim 	= new DimInfo;
    new_val->dim->width	= width;
    new_val->dim->heigh = heigh;
    new_val->dim->depth = depth;

    // 0(NULL)֤Ǥ뤳ȤȤ
    bzero((void*)&new_val->div_hint, sizeof(int)      * MAX_DIM);
    bzero((void*)&new_val->div_info, sizeof(DivInfo*) * MAX_DIM);


    // ǥեȤʬʤɤ˴ؤ  --------------------------
    new_val->dim->cache = 0;
    new_val->dtype 	= dPIXEL;


    switch(type) {			// ͤΰ
      case iCUB :
	new_val->val = new int[new_val->size];
	bzero(new_val->val, new_val->size * sizeof(int));
	break;
      case fCUB :
	new_val->val = new FLOAT[new_val->size];
	bzero(new_val->val, new_val->size * sizeof(FLOAT));
    }
    
                                         // ѿ̾
    size_t size   	= strlen(name)+1;
    new_val->name 	= new char[size];
    memcpy(new_val->name, (void*)name, size);


    new_val->next	= begin.next;
    begin.next		= new_val;

    return new_val;
}


void
OmTable::remake(vs_data* ptr){    ptr->id    = count++;    }




//  ơ֥λ  -------------------------------------------
//                  Ψ٤夬Τʤ׽񤭴

vs_data*
OmTable::get(const char* req_name)
{
    for(vs_data* ptr = begin.next; ptr != NULL; ptr = ptr->next) {
	if(!(strcmp((char*)ptr->name, req_name))) return ptr;
    }
    return NULL;
}

vs_data*
OmTable::get(int req_id)
{
    for(vs_data* ptr = begin.next; ptr != NULL; ptr = ptr->next)
	if(ptr->id == req_id)	return ptr;

    return NULL;
}
